//---------------------------------------------------------------------------
#pragma hdrstop
#include "FileData.h"
#include "Main.h"
#include "Data.h"
#include "EntryData.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//------------------------------------------------------------------------------
/*
############################################################################
Return various DAT properties that are used in different situations.
Look around to see a particular use of a property, but they're fairly
self-explanatory.
############################################################################
*/
bool FileData::GetLoadState() {
     return this->IsLoaded;
};
//------------------------------------------------------------------------------
int* FileData::GetData () {
     return this->Data;
};
//------------------------------------------------------------------------------
int FileData::GetDatacount () {
    return this->datacount;
};
//------------------------------------------------------------------------------
int FileData::GetOffcount () {
    return this->offcount;
};
//------------------------------------------------------------------------------
int FileData::GetFilesize () {
    return this->filesize;
};
//------------------------------------------------------------------------------
bool FileData::GetDefaultState () {
     return this->IsDefault;
};
//------------------------------------------------------------------------------
bool FileData::GetIsMPQImport () {
     return this->IsMPQImport;
};

void FileData::SetIsMPQImport(bool Value) {
     this->IsMPQImport = Value;
};
//------------------------------------------------------------------------------
bool FileData::GetFormatLoaded () {
     return this->FormatLoaded;
};

void FileData::SetFormatLoaded(bool Value) {
     this->FormatLoaded = Value;
};
//------------------------------------------------------------------------------
String FileData::GetDatName () {
    return this->DatName;
};
/*
############################################################################
Set a FileData object's DatName variable, which is the filename of the
edited DAT file. Also check if the file is a default one i.e. if it has
"default" in its filename.
############################################################################
*/

void FileData::SetDatName(String FileName) {
     this->DatName = FileName;
     this->IsDefault = false;
     this->IsLoaded = true;
     if (FileName.Pos("default") != 0) {
        this->IsDefault = true;
     }
};
//------------------------------------------------------------------------------
/*
############################################################################
Load to the memory the hex format of a specific DAT file. I've hard-coded
this instead of having an external format file (like AZero does).
############################################################################
*/
void FileData::LoadFormat (String Format) {
       /*
for (int i=0;i<11;i++) {
    if (Format == GetDATType(i)) {
       this->datacount=
       this->offcount=
       this->Data = new int [datacount*offcount];
       this->Off = new int [offcount];
       this->OffSize = new int [offcount];
       this->TempEntry = new int [offcount];
       int offSize[]
       int off[]
       for (int i=0;i<this->offcount;i++) {
           this->OffSize[i] = offSize[i];
           this->Off[i] = off[i];
        }
    }
    GetDATSpec
  */

   if (Format == "weapons") {
        this->datacount=130;
        this->offcount=24;
        this->filesize=5460;
        this->Data = new int [datacount*offcount];
        this->Off = new int [offcount];
        this->OffSize = new int [offcount];
        this->TempEntry = new int [offcount];
        int offSize[24] = {2,4,1,2,4,4,1,1,1,1,1,2,2,2,2,2,1,1,1,1,1,1,2,2};
        int off[24] = {0x0000,0x0104,0x030C,0x038E,0x0492,0x069A,0x08A2,0x0924,0x09A6,0x0A28,0x0AAA,0x0B2C,0x0C30,0x0D34,0x0E38,0x0F3C,0x1040,0x10C2,0x1144,0x11C6,0x1248,0x12CA,0x134C,0x1450};
        for (int i=0;i<this->offcount;i++) {
           this->OffSize[i] = offSize[i];
           this->Off[i] = off[i];
        }
   }
   else if (Format == "upgrades") {
        this->datacount=61;
        this->offcount=12;
        this->filesize=1281;
        this->Data = new int [datacount*offcount];
        this->Off = new int [offcount];
        this->OffSize = new int [offcount];
        this->TempEntry = new int [offcount];
        int offSize[12] = {2,2,2,2,2,2,2,2,2,1,1,1};
        int off[12] = {0x0000,0x007A,0x00F4,0x016E,0x01E8,0x0262,0x02DC,0x0356,0x03D0,0x044A,0x0487,0x04C4};
	for (int i=0;i<this->offcount;i++) {
            this->OffSize[i] = offSize[i];
            this->Off[i] = off[i];
        }
   }
   else if (Format == "units") {
        this->datacount=228;
	this->offcount=55;
        this->filesize=19876;
	this->Data = new int [datacount*offcount];
	this->Off = new int [offcount];
	this->OffSize = new int [offcount];
	this->TempEntry = new int [offcount];
        this->TempTab = new int [offcount];
        this->TempMix = new int [offcount];
        int offSize[55] = {1,2,2,5,4,1,1,2,4,1,1,1,1,1,1,1,1,1,1,1,1,1,4,1,1,1,1,1,1,6,2,2,6,6,6,6,4,7,8,8,2,2,2,2,2,1,1,1,1,1,2,2,2,1,2};
	int off[55] = {0x0000,0x00E4,0x02AC,0x0474,0x0534,0x08C4,0x09A8,0x0A8C,0x0C54,0x0FE4,0x010C8,0x11AC,0x1290,0x1374,0x1458,0x153C,0x1620,0x1704,0x17E8,0x18CC,0x19B0,0x1A94,0x1B78,0x1F08,0x1FEC,0x20D0,0x21B4,0x2298,0x237C,0x2460,0x2534,0x26FC,0x28C4,0x2998,0x2A6C,0x2B40,0x2C14,0x2FA4,0x3124,0x3128,0x3844,0x3A0C,0x3BD4,0x3D9C,0x3F64,0x412C,0x4210,0x42F4,0x43D8,0x44BC,0x45A0,0x4768,0x4930,0x4AF8,0x4BDC};
	for (int i=0;i<this->offcount;i++) {
            this->OffSize[i] = offSize[i];
	    this->Off[i] = off[i];
	}
   }
   else if (Format == "techdata") {
	this->datacount=44;
	this->offcount=10;
        this->filesize=836;
	this->Data = new int [datacount*offcount];
	this->Off = new int [offcount];
	this->OffSize = new int [offcount];
	this->TempEntry = new int [offcount];
        int offSize[10] = {2,2,2,2,4,2,2,1,1,1};
	int off[10] = {0x0000,0x0058,0x00B0,0x0108,0x0160,0x0210,0x0268,0x02C0,0x02EC,0x0318};
	for (int i=0;i<this->offcount;i++) {
	    this->OffSize[i] = offSize[i];
	    this->Off[i] = off[i];
	}
   }
   else  if (Format == "sprites") {
	this->datacount=517;
	this->offcount=6;
        this->filesize=3229;
	this->Data = new int [datacount*offcount];
	this->Off = new int [offcount];
	this->OffSize = new int [offcount];
	this->TempEntry = new int [offcount];
        int offSize[6] = {2,3,1,1,3,3};
	int off[6] = {0x0000,0x040A,0x058D,0x0792,0x0997,0x0B1A};
	for (int i=0;i<this->offcount;i++) {
	    this->OffSize[i] = offSize[i];
	    this->Off[i] = off[i];
	}
   }
   else if (Format == "sfxdata"){
	this->datacount=1144;
	this->offcount=5;
        this->filesize=10296;
	this->Data = new int [datacount*offcount];
	this->Off = new int [offcount];
	this->OffSize = new int [offcount];
	this->TempEntry = new int [offcount];
        int offSize[5] = {4,1,1,2,1};
	int off[5] = {0x0000,0x11E0,0x1658,0x1AD0,0x23C0};
	for (int i=0;i<this->offcount;i++) {
	    this->OffSize[i] = offSize[i];
	    this->Off[i] = off[i];
	}
   }
   else if (Format == "portdata"){
	this->datacount=220;
	this->offcount=3;
        this->filesize=1320;
	this->Data = new int [datacount*offcount];
	this->Off = new int [offcount];
	this->OffSize = new int [offcount];
	this->TempEntry = new int [offcount];
        int offSize[3] = {4,1,1};
	int off[3] = {0x0000,0x0370,0x044C};
	for (int i=0;i<this->offcount;i++) {
	    this->OffSize[i] = offSize[i];
	    this->Off[i] = off[i];
	}
   }
   else if (Format == "orders"){
	this->datacount=189;
	this->offcount=19;
        this->filesize=4158;
	this->Data = new int [datacount*offcount];
	this->Off = new int [offcount];
	this->OffSize = new int [offcount];
	this->TempEntry = new int [offcount];
        int offSize[19] = {2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,1};
	int off[19] = {0x0000,0x017A,0x0237,0x02F4,0x03B1,0x046E,0x052B,0x05E8,0x06A5,0x0762,0x081F,0x08DC,0x0999,0x0A56,0X0B13,0x0BD0,0x0C8D,0x0E07,0x0F81};
   	for (int i=0;i<this->offcount;i++) {
	    this->OffSize[i] = offSize[i];
	    this->Off[i] = off[i];
    	}
   }
   else if (Format == "mapdata") {
	this->datacount=65;
	this->offcount=1;
        this->filesize=260;
	this->Data = new int [datacount*offcount];
	this->Off = new int [offcount];
	this->OffSize = new int [offcount];
        this->TempEntry = new int [offcount];
        int offSize[1] = {4};
	int off[1] = {0x0000};
	for (int i=0;i<this->offcount;i++) {
	    this->OffSize[i] = offSize[i];
	    this->Off[i] = off[i];
	}
   }
   else if (Format == "images") {
	this->datacount=999;
	this->offcount=14;
        this->filesize=37962;
	this->Data = new int [datacount*offcount];
	this->Off = new int [offcount];
	this->OffSize = new int [offcount];
        this->TempEntry = new int [offcount];
        int offSize[14] = {4,1,1,1,1,1,1,4,4,4,4,4,4,4};
	int off[14] = {0x0000,0x0F9C,0x1383,0x176A,0x1B51,0x1F38,0x231F,0x2706,0x36A2,0x463E,0x55DA,0x6576,0x7512,0x84AE};
	for (int i=0;i<this->offcount;i++) {
	    this->OffSize[i] = offSize[i];
	    this->Off[i] = off[i];
	}
   }
   else if (Format == "flingy") {
        this->datacount=209;
        this->offcount=7;
        this->filesize=3135;
        this->Data = new int [datacount*offcount];
        this->Off = new int [offcount];
        this->OffSize = new int [offcount];
        this->TempEntry = new int [offcount];
        int offSize[7]= {2,4,2,4,1,1,1};
        int off[7] = {0x0000,0x01A2,0x04E6,0x0688,0x09CC,0x0A9D,0x0B6E};
        for (int i=0;i<this->offcount;i++) {
	    this->OffSize[i] = offSize[i];
	    this->Off[i] = off[i];
        }
   }
};
//------------------------------------------------------------------------------
/*
############################################################################
This is the core of the whole program. This routine parses through
a DAT file according to a given format (see above) and stores the data
in the 'Data' array.
Important is, that differently to how the data is originally organized
in the DAT files, the 'Data' array is structured-by-object and not
structured-by-property, like the original DAT files are.
Basically, this means that while the DAT file are structured in the following way:
     "Property1 for entry1",
     "Property1 for entry2",
     ...
     "Property2 for entry1",
     "Property2 for entry2",
     etc...

the 'Data' array is constructed the other way round:
    "Property1 for entry1",
    "Property2 for entry1",
    ...
    "Property1 for entry2",
    "Property2 for entry2",

This allows -to my mind at least- a much easier access to the needed
data and is a more straightforward method of doing the job.
############################################################################
*/

//void FileData::LoadData (String FileName) {
void FileData::LoadData (void* InputBuffer) {
     void *Buffer;
     TMemoryStream *DatFile = new TMemoryStream();

     if (DatFile != NULL && Buffer != NULL) {
        DatFile->SetSize(this->GetFilesize());
        DatFile->Seek(0,soFromBeginning);
        DatFile->Write(InputBuffer,this->GetFilesize());

        for (int j=0;j<this->datacount;j++) {
             for (int i=0;i<this->offcount;i++) {
                 switch (this->OffSize[i]) {
                        case 1:
                             DatFile->Seek(this->Off[i]+(this->OffSize[i]*j),soFromBeginning);
                             DatFile->Read(&Buffer,1);
                             this->Data[(j*this->offcount)+i] = (unsigned char) (Buffer);
			     break;
			case 2:
                             DatFile->Seek(this->Off[i]+(this->OffSize[i]*j),soFromBeginning);
                             DatFile->Read(&Buffer,2);
                             this->Data[(j*this->offcount)+i] = (unsigned short) (Buffer);
			     break;
			case 3:
			     if (j<130) {
				this->Data[(j*this->offcount)+i] = 0;
			     }
			     else if (j>=130 && j<this->datacount) {
                             DatFile->Seek(this->Off[i]+(j-130),soFromBeginning);
                             DatFile->Read(&Buffer,1);
                             this->Data[(j*this->offcount)+i] = (unsigned char) (Buffer);
			     }
			     break;
			case 4:
                             DatFile->Seek(this->Off[i]+(this->OffSize[i]*j),soFromBeginning);
                             DatFile->Read(&Buffer,4);
                             this->Data[(j*this->offcount)+i] = (unsigned long) (Buffer);
			     break;
			case 5:
			     if (j<106 || j>201) {
				this->Data[(j*this->offcount)+i] = 0;
			     }
			     else if (j>=106 && j<=201) {
                             DatFile->Seek(this->Off[i]+(2*(j-106)),soFromBeginning);
                             DatFile->Read(&Buffer,2);
                             this->Data[(j*this->offcount)+i] = (unsigned short) (Buffer);
			     }
			     break;
			case 6:
			     if (j>=106) {
				this->Data[(j*this->offcount)+i] = 0;
			     }
			     else if (j<106) {
                             DatFile->Seek(this->Off[i]+(2*j),soFromBeginning);
                             DatFile->Read(&Buffer,2);
                             this->Data[(j*this->offcount)+i] = (unsigned short) (Buffer);
			     }
			     break;
			case 7:
			     if (j<106 || j>201) {
				this->Data[(j*this->offcount)+i] = 0;
			     }
			     else if (j>=106 && j<=201) {
                             DatFile->Seek(this->Off[i]+(4*(j-106)),soFromBeginning);
                             DatFile->Read(&Buffer,4);
                             this->Data[(j*this->offcount)+i] = (unsigned long) (Buffer);
			     }
			     break;
			case 8:
                             DatFile->Seek(this->Off[i]+(this->OffSize[i]*j),soFromBeginning);
                             DatFile->Read(&Buffer,4);
                             this->Data[(j*this->offcount)+i] = (unsigned long) (Buffer);
			     break;
		 }
	     }
	   }
     delete DatFile;
     }
};
//------------------------------------------------------------------------------
/*
############################################################################
This is a twin-brother to the loading routine, it just works the opposite
way: it takes the data from the memory (the 'Data' array) and outputs
them to a specific DAT file, according to a given format.
############################################################################
*/

void FileData::SaveData (String FileName) {
     void *Buffer;
     TFileStream *DatFile = new TFileStream(FileName,fmCreate);

     	  for (int i=0;i<this->offcount;i++) {
	      for (int j=0;j<this->datacount;j++) {
		  switch (this->OffSize[i]) {
                         case 1:
			     Buffer = &(this->Data[j*this->offcount+i]);
			     DatFile->Seek(this->Off[i]+this->OffSize[i]*j,soFromBeginning);
			     DatFile->Write(Buffer, 1);
			     break;
			 case 2:
			     Buffer = &(this->Data[j*this->offcount+i]);
			     DatFile->Seek(this->Off[i]+this->OffSize[i]*j,soFromBeginning);
			     DatFile->Write(Buffer, 2);
                             break;
			 case 3:
			     if (j>=130) {
			     Buffer = &(this->Data[j*this->offcount+i]);
			     DatFile->Seek(this->Off[i]+(j-130),soFromBeginning);
			     DatFile->Write(Buffer, 2);
			     }
			     break;
			 case 4:
			     Buffer = &(this->Data[j*this->offcount+i]);
			     DatFile->Seek(this->Off[i]+this->OffSize[i]*j,soFromBeginning);
			     DatFile->Write(Buffer, 4);
			     break;
			case 5:
			     if (j >=106 && j<=201) {
			     Buffer = &(this->Data[(j*this->offcount)+i]);
                             DatFile->Seek(this->Off[i]+(2*(j-106)),soFromBeginning);
			     DatFile->Write(Buffer, 2);
			     }
			     break;
			case 6:
			     if (j<106) {
			     Buffer = &(this->Data[(j*this->offcount)+i]);
                             DatFile->Seek(this->Off[i]+(2*j),soFromBeginning);
			     DatFile->Write(Buffer, 2);
			     }
			     break;
			case 7:
                             if (j>=106 && j<=201) {
                             Buffer = &(this->Data[(j*this->offcount)+i]);
                             DatFile->Seek(this->Off[i]+(4*(j-106)),soFromBeginning);
			     DatFile->Write(Buffer, 4);
			     }
			     break;
			case 8:
			     Buffer = &(this->Data[(j*this->offcount)+i]);
                             DatFile->Seek(this->Off[i]+(this->OffSize[i]*j),soFromBeginning);
			     DatFile->Write(Buffer, 4);
			     break;
		  }
	      }
	  }
     DatFile->Size=this->GetFilesize();
     delete DatFile;
};
//------------------------------------------------------------------------------
/*
############################################################################
The following functions control the 3 different ways the Copy/Paste may
work in DatEdit. Note that there are 3 different arrays that store the
data, each for a different method: Copying entire entries, copying only
one tab and the mixed option.
############################################################################
*/
void FileData::CopyTempEntry (int EntryID) {
     for (int i=0;i<this->offcount;i++) {
         this->TempEntry[i] = this->Data[EntryID*offcount+i];
         if (Form1->GetPage() == 0) {
            this->TempMix[i] = this->Data[EntryID*offcount+i];
         }
     }
     Form1->SetTempDats(Form1->GetPage(), true);
};
//------------------------------------------------------------------------------
void FileData::PasteTempEntry (int EntryID) {
     for (int i=0;i<this->offcount;i++) {
         this->Data[EntryID*this->offcount+i] = this->TempEntry[i];
     }
};
//------------------------------------------------------------------------------
/*
############################################################################
A few words of explanation here: the special custom code for the Data
property '45' is there because the property is split into two tabs:
'Basic' and 'StarEdit'. The code only copies the part of the value
belonging to the currently used tab, leaving the rest unchanged.
############################################################################
*/

void FileData::CopyTab (int EntryID,int Tab) {
     for (int i=0,k=0;i<this->GetOffcount();i++) {
         if (i==GetTabMemoryOffs(Tab)[k]) {
            if (i==45) {
               unsigned char temp[3];
               temp[0] = this->Data[EntryID*offcount+45];
               temp[1] = this->TempTab[45];
               temp[2] = this->TempMix[45];

               switch (Tab) {
                      case 0:
                           temp[0] = temp[0]*32;
                           temp[0] = temp[0]/32;
                           for (int i=1;i<3;i++) {
                               temp[i] = temp[i]/8;
                               temp[i] = temp[i]*8;
                           }
                           break;
                      case 4:
                           temp[0] = temp[0]/8;
                           temp[0] = temp[0]*8;
                           for (int i=1;i<3;i++) {
                               temp[i] = temp[i]*32;
                               temp[i] = temp[i]/32;
                           }
                           break;
               }
               this->TempTab[45] = temp[0]+temp[1];
               this->TempMix[45] = temp[0]+temp[2];
            }
            else {
               this->TempTab[i] = this->Data[EntryID*offcount+GetTabMemoryOffs(Tab)[k]];
               this->TempMix[i] = this->Data[EntryID*offcount+GetTabMemoryOffs(Tab)[k]];
            }
            k++;
         }
     }
     Form1->SetTempTabs(Form1->GetSubPage(),true);
};
//------------------------------------------------------------------------------
void FileData::PasteTab (int EntryID,int Tab) {
     for (int i=0,k=0;i<this->GetOffcount();i++) {
         if (i==GetTabMemoryOffs(Tab)[k]) {
            if (i==45) {
               unsigned char temp[2];
               temp[0] = this->TempTab[45];
               temp[1] = this->Data[EntryID*offcount+45];

               switch (Tab) {
                      case 0:
                           temp[0] = temp[0]*32;
                           temp[0] = temp[0]/32;
                           temp[1] = temp[1]/8;
                           temp[1] = temp[1]*8;
                           break;
                      case 4:
                           temp[0] = temp[0]/8;
                           temp[0] = temp[0]*8;
                           temp[1] = temp[1]*32;
                           temp[1] = temp[1]/32;
                           break;
               }
               this->Data[EntryID*offcount+45] = temp[0]+temp[1];
            }
            else {
               this->Data[EntryID*offcount+GetTabMemoryOffs(Tab)[k]] = this->TempTab[i];
            }
            k++;
         }
     }
};
//------------------------------------------------------------------------------
void FileData::PasteMix (int EntryID) {
     for (int i=0;i<this->GetOffcount();i++) {
         this->Data[EntryID*this->offcount+i] = this->TempMix[i];
     }
};
//------------------------------------------------------------------------------
/*
############################################################################
Reload a specific entry from default. The loading function is the same as
in the LoadData function, just that the 'j' variable (entry index) is set
to a specific entry ID value instead of going through all of them.
############################################################################
*/
void FileData::ReloadEntryFromDefault (int EntryID) {
     void *Buffer;

     String FileName = Form1->GetProgPath()+"default//"+GetDATType(Form1->GetPage())+".dat";
     TFileStream *DatFile = new TFileStream(FileName,fmOpenRead);

     int j = EntryID;
     for (int i=0;i<this->offcount;i++) {
         switch (this->OffSize[i]) {
                        case 1:
                             DatFile->Seek(this->Off[i]+(this->OffSize[i]*j),soFromBeginning);
                             DatFile->Read(&Buffer,1);
                             this->Data[(j*this->offcount)+i] = (unsigned char) (Buffer);
			     break;
			case 2:
                             DatFile->Seek(this->Off[i]+(this->OffSize[i]*j),soFromBeginning);
                             DatFile->Read(&Buffer,2);
                             this->Data[(j*this->offcount)+i] = (unsigned short) (Buffer);
			     break;
			case 3:
			     if (j<130) {
				this->Data[(j*this->offcount)+i] = 0;
			     }
			     else if (j>=130 && j<this->datacount) {
                             DatFile->Seek(this->Off[i]+(j-130),soFromBeginning);
                             DatFile->Read(&Buffer,1);
                             this->Data[(j*this->offcount)+i] = (unsigned char) (Buffer);
			     }
			     break;
			case 4:
                             DatFile->Seek(this->Off[i]+(this->OffSize[i]*j),soFromBeginning);
                             DatFile->Read(&Buffer,4);
                             this->Data[(j*this->offcount)+i] = (unsigned long) (Buffer);
			     break;
			case 5:
			     if (j<106 || j>201) {
				this->Data[(j*this->offcount)+i] = 0;
			     }
			     else if (j>=106 && j<=201) {
                             DatFile->Seek(this->Off[i]+(2*(j-106)),soFromBeginning);
                             DatFile->Read(&Buffer,2);
                             this->Data[(j*this->offcount)+i] = (unsigned short) (Buffer);
			     }
			     break;
			case 6:
			     if (j>=106) {
				this->Data[(j*this->offcount)+i] = 0;
			     }
			     else if (j<106) {
                             DatFile->Seek(this->Off[i]+(2*j),soFromBeginning);
                             DatFile->Read(&Buffer,2);
                             this->Data[(j*this->offcount)+i] = (unsigned short) (Buffer);
			     }
			     break;
			case 7:
			     if (j<106 || j>201) {
				this->Data[(j*this->offcount)+i] = 0;
			     }
			     else if (j>=106 && j<=201) {
                             DatFile->Seek(this->Off[i]+(4*(j-106)),soFromBeginning);
                             DatFile->Read(&Buffer,4);
                             this->Data[(j*this->offcount)+i] = (unsigned long) (Buffer);
			     }
			     break;
			case 8:
                             DatFile->Seek(this->Off[i]+(this->OffSize[i]*j),soFromBeginning);
                             DatFile->Read(&Buffer,4);
                             this->Data[(j*this->offcount)+i] = (unsigned long) (Buffer);
			     break;
         }
     }
     delete DatFile;
};
//------------------------------------------------------------------------------

