/*
############################################################################
   DATEDIT source code - A Logical Knot/Star Alliance release;
   Made by BroodKiller (Jacek Kominek) 2005-2006.
                                                   
   This is the complete C++ source code that makes up for
   DatEdit, application used to edit the *.DAT data files
   used in the Blizzard RTS game StarCraft. I didn't hide
   anything from you, this code will compile into the very
   same application that you can download from the web.

   Please, remember that all the comments that are put here
   have been made exclusively for this release. Normally
   I don't do anything like that but I tried to comment this
   code to the best of my abilities.
   Also, keep in mind that these comments are intended to help
   those of you with already some programming experience.
   DO NOT, and let me repeat this, DO NOT look into this code if
   you're just starting your adventure with C++ or Borland C++ Builder.
   You may learn some bad habits from it, and I don't want to
   be responsible for that.
   For more, while writing this code, I myself was still
   learning and discovering many things about C++/VCL
   programming. Thus, some problems may be solved one way
   in one part of the program, and in another way elsewhere.
   Don't blame me for it - rather try to learn on my mistakes :)

   Finally, I am aware that, as a whole, this code sucks,
   and that it sucks A LOT. But a friend of mine told me once
   this phrase:

   "First of all, make it work - everything else is optional".

   And I agree with this. After all, my point was to give to the
   community a useful and working application, not a beautiful
   source code. 8)

   If these lines of C++-code-wannabe will help or inspire you
   in any way - that's great. I don't require you to credit me for
   anything you do with what is included here, although it would
   be nice if you mention me somewhere around the Credits if
   you would directly copy some parts from DatEdit's code 8)
   Remeber: "Sharing is caring", so

      Open source all the way!

   -BroodKiller

############################################################################
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "About.h"
#include "LoadList.h"
#include "Data.h"
#include "TBLParser.h"
#include "Credits.h"
#include "LoadDir.h"
#include "MultiMPQ.h"
#include "DoodadInfo.h"
#include "EntryData.h"
#include "FileData.h"
#include "Options.h"
#include "TForm1.h"
#include "Hints.h"
#include "Splash.h"
#include "EditTBL.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
/*
############################################################################
Program initial routine, includes: initializing program internals,(version,
paths etc.) reading the config INI file and loading default DAT files.
############################################################################
*/

void __fastcall TForm1::FormCreate(TObject *Sender)
{
InitializeValues();
if (DirectoryExists(GetProgPath()+"default\\") && DirectoryExists(GetProgPath()+"Data\\")) {
   Form1->ReadConfig->Execute();

   for (int i=10;i>=0;i--) {
       CheckDATFile((GetProgPath())+"default\\"+GetDATType(i)+".dat");
   }
   Form1->Editors->ActivePageIndex = Form1->StartEditor;
   ChangeTab->Execute();
}
else {
   if (!DirectoryExists(GetProgPath()+"default\\")) {
      MessageDlg("The default DAT directory not found.\n       DatEdit will now terminate.", mtError, TMsgDlgButtons() << mbOK, 0);
      Application->Terminate();
   }
   else {
      if (!DirectoryExists(GetProgPath()+"Data\\")) {
         MessageDlg("The program Data directory not found.\n       DatEdit will now terminate.", mtError, TMsgDlgButtons() << mbOK, 0);
         Application->Terminate();
      }
   }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Program pre-terminal routine. Displays the "Are you sure?" dialog.
############################################################################
*/
void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
ReadConfigOptions->Execute();
CanClose = true;
if (OptionsBox->ConfirmOnExit->Checked == true) {
     if (MessageDlg("Are you sure you want to exit DatEdit?", mtConfirmation, mbOKCancel, 0) == 1) {
        CanClose = true;
     }
     else
        CanClose = false;
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Program terminal routine, that writes to the config INI file.
############################################################################
*/
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
Form1->SaveConfig->Execute();
Form1->SaveConfigOptions->Execute();
ClearTemp();
}
//---------------------------------------------------------------------------
/*
############################################################################
This and the the few following functions call a custom routine (LoadList
or LoadTBLList) that handles loading of the appropriate lists from the
text files (or a TBL) from the "Data/" dir to the correct dropdown boxes
in different editors (you can easily guess which particular editor is in
question from the function name).
############################################################################
*/
/*
############################################################################
UNITS EDITOR
############################################################################
*/

void __fastcall TForm1::UnitBasicShow(TObject *Sender)
{
if (Form1->UnitWeaponGroundList->Items->Count == 0) {
   LoadList(Form1->UnitWeaponGroundList,"Weapons");
}
if (Form1->UnitWeaponAirList->Items->Count == 0) {
   LoadList(Form1->UnitWeaponAirList,"Weapons");
}
if (Form1->UnitArmUpgrade->Items->Count == 0) {
   LoadList(Form1->UnitArmUpgrade,"Upgrades");
}
if (Form1->UnitSize->Items->Count == 0) {
   LoadList(Form1->UnitSize,"UnitSize");
}
};
//---------------------------------------------------------------------------

void __fastcall TForm1::UnitAdvShow(TObject *Sender)
{
if (Form1->UnitSub1->Items->Count == 0) {
   LoadList(Form1->UnitSub1,"Units");
}
if (Form1->UnitSub2->Items->Count == 0) {
   LoadList(Form1->UnitSub2,"Units");
}
};
//---------------------------------------------------------------------------

void __fastcall TForm1::UnitSoundShow(TObject *Sender)
{
if (Form1->UnitSndReadyList->Items->Count == 0) {
   LoadList(Form1->UnitSndReadyList,"sfxdata");
}
if (Form1->UnitSndAnnStartList->Items->Count == 0) {
   LoadList(Form1->UnitSndAnnStartList,"sfxdata");
}
if (Form1->UnitSndAnnEndList->Items->Count == 0) {
   LoadList(Form1->UnitSndAnnEndList,"sfxdata");
}
if (Form1->UnitSndWhatStartList->Items->Count == 0) {
   LoadList(Form1->UnitSndWhatStartList,"sfxdata");
}
if (Form1->UnitSndWhatEndList->Items->Count == 0) {
   LoadList(Form1->UnitSndWhatEndList,"sfxdata");
}
if (Form1->UnitSndYesStartList->Items->Count == 0) {
   LoadList(Form1->UnitSndYesStartList,"sfxdata");
}
if (Form1->UnitSndYesEndList->Items->Count == 0) {
   LoadList(Form1->UnitSndYesEndList,"sfxdata");
}
};
//---------------------------------------------------------------------------

void __fastcall TForm1::UnitGraphicsShow(TObject *Sender)
{
if (Form1->UnitGfx->Items->Count == 0) {
   LoadList(Form1->UnitGfx,"Flingy");
}
if (Form1->UnitConst->Items->Count == 0) {
   LoadList(Form1->UnitConst,"Images");
}
if (Form1->UnitInfest->Items->Count == 0) {
   LoadList(Form1->UnitInfest,"Units");
}
if (Form1->UnitPort->Items->Count == 0) {
   LoadList(Form1->UnitPort,"Portdata");
}
if (Form1->UnitAnimLevel->Items->Count == 0) {
   LoadList(Form1->UnitAnimLevel,"AnimLevels");
}
Form1->SizeRefPoint->Left = (Form1->UnitDimView->Width)/2;
Form1->SizeRefPoint->Top = (Form1->UnitDimView->Height)/2;
Form1->SizeRect->Left = (Form1->UnitDimView->Width)/2;
Form1->SizeRect->Top = (Form1->UnitDimView->Height)/2;

TIniFile *ConfigIni = new TIniFile(GetProgPath()+"DatEdit.ini");
if (ConfigIni->SectionExists("Options")) {
   Form1->SizeRefPoint->Visible = ConfigIni->ReadBool("Options","ShowUnitSizePreview",true);
   Form1->SizeRect->Visible = ConfigIni->ReadBool("Options","ShowUnitSizePreview",true);
}
delete ConfigIni;
};
//---------------------------------------------------------------------------

void __fastcall TForm1::UnitSEShow(TObject *Sender)
{
if (GetEditorReload(0) == true) {
   LoadTBLMemo(Form1->UnitSubMemo,"stat_txt");

//A CUSTOM ROUTINE TO LOAD THE ENTRIES FOR THE "RANK" PROPERTY.
//IT IS A 1301-BASED, 2-BYTES BIG STAT_TXT.TBL POINTER 
   {
   Form1->UnitSublabel->Clear();
   Form1->UnitSublabel->Items->Add("No sublabel");
   for (int i=1302;i<Form1->UnitSubMemo->Lines->Count;i++) {
       if (i>=1556) {
          break;
       }
       Form1->UnitSublabel->Items->Add(Form1->UnitSubMemo->Lines->Strings[i]);
   }
   }

   SetEditorReload(0,false);
}
};
//---------------------------------------------------------------------------

void __fastcall TForm1::UnitAIShow(TObject *Sender)
{
if (Form1->UnitAICompIdle->Items->Count == 0) {
   LoadList(Form1->UnitAICompIdle,"Orders");
}
if (Form1->UnitAIHumanIdle->Items->Count == 0) {
   LoadList(Form1->UnitAIHumanIdle,"Orders");
}
if (Form1->UnitAIAttackUnit->Items->Count == 0) {
   LoadList(Form1->UnitAIAttackUnit,"Orders");
}
if (Form1->UnitAIAttackMove->Items->Count == 0) {
   LoadList(Form1->UnitAIAttackMove,"Orders");
}
if (Form1->UnitAIReturn->Items->Count == 0) {
   LoadList(Form1->UnitAIReturn,"Orders");
}
if (Form1->UnitAIRightClick->Items->Count == 0) {
   LoadList(Form1->UnitAIRightClick,"RightClick");
}
};
//---------------------------------------------------------------------------
/*
############################################################################
WEAPONS EDITOR
############################################################################
*/

void __fastcall TForm1::WeapEditShow(TObject *Sender)
{
if (GetEditorReload(1) == true) {
   LoadTBLList (Form1->WeapLabel,"stat_txt");
   LoadTBLList (Form1->WeapError,"stat_txt");
   SetEditorReload(1,false);
}
if (Form1->WeapGraphicsList->Items->Count ==0) {
   LoadList(Form1->WeapGraphicsList,"Flingy");
}
if (Form1->WeapIconList->Items->Count ==0) {
   LoadList(Form1->WeapIconList,"Icons");
}
if (Form1->WeapUpgrade->Items->Count ==0) {
   LoadList(Form1->WeapUpgrade,"Upgrades");
}
if (Form1->WeapBehaviour->Items->Count ==0) {
   LoadList(Form1->WeapBehaviour,"Behaviours");
}
if (Form1->WeapUnused->Items->Count ==0) {
   LoadList(Form1->WeapUnused,"Techdata");
}
if (Form1->WeapType->Items->Count ==0) {
   LoadList(Form1->WeapType,"DamTypes");
}
if (Form1->WeapExplosion->Items->Count ==0) {
   LoadList(Form1->WeapExplosion,"Explosions");
}
if (Form1->WeapMissile->Items->Count ==0) {
   LoadList(Form1->WeapMissile,"MissileType");
}
};
//---------------------------------------------------------------------------
/*
############################################################################
FLINGY EDITOR
############################################################################
*/

void __fastcall TForm1::FlingyEditShow(TObject *Sender)
{
if (Form1->FlingyMoveControl->Items->Count ==0) {
   LoadList(Form1->FlingyMoveControl,"FlingyControl");
}
if (Form1->FlingySpriteList->Items->Count ==0) {
   LoadList(Form1->FlingySpriteList,"Sprites");
}
};
//---------------------------------------------------------------------------
/*
############################################################################
SPRITES EDITOR
############################################################################
*/

void __fastcall TForm1::SpriteEditShow(TObject *Sender)
{
if (Form1->SpriteCircleSize->Items->Count ==0) {
   LoadList(Form1->SpriteCircleSize,"SelCircleSize");
}
if (Form1->SpriteImageList->Items->Count ==0) {
   LoadList(Form1->SpriteImageList,"Images");
}
};
//---------------------------------------------------------------------------
/*
############################################################################
IMAGES EDITOR
############################################################################
*/

void __fastcall TForm1::ImageEditShow(TObject *Sender)
{
if (Form1->ImgPalette->Items->Count == 0) {
   LoadList(Form1->ImgPalette,"PalList");
}
if (Form1->ImgPalSpec->Items->Count == 0) {
   LoadList(Form1->ImgPalSpec,"PalSpecial");
}
if (Form1->ImgShieldOL->Items->Count == 0) {
   LoadList(Form1->ImgShieldOL,"ShieldSize");
}
if (Form1->ImgIscriptIDList->Items->Count == 0) {
   LoadList(Form1->ImgIscriptIDList,"IscriptIDList");
}
if (GetEditorReload(4) == true) {
   LoadTBLList(Form1->ImgGRPTBL,"images");
   Form1->ImgOL1TBL->Items = Form1->ImgGRPTBL->Items;
   Form1->ImgOL2TBL->Items = Form1->ImgGRPTBL->Items;
   Form1->ImgOL3TBL->Items = Form1->ImgGRPTBL->Items;
   Form1->ImgOL4TBL->Items = Form1->ImgGRPTBL->Items;
   Form1->ImgOL5TBL->Items = Form1->ImgGRPTBL->Items;
   Form1->ImgShieldTBL->Items = Form1->ImgGRPTBL->Items;
   SetEditorReload(4,false);
/*
IT IS FASTER TO COPY THE CONTENTS FROM ONE COMBOBOX TO ANOTHER
THAN TO PARSE THE TBL FOR EACH OF THEM.
*/
}
};
//---------------------------------------------------------------------------
/*
############################################################################
UPGRADE EDITOR
############################################################################
*/

void __fastcall TForm1::UpgradeEditShow(TObject *Sender)
{
if (Form1->UpgIconList->Items->Count == 0) {
   LoadList(Form1->UpgIconList,"Icons");
}
if (Form1->UpgRace->Items->Count == 0) {
   LoadList(Form1->UpgRace,"Races");
}
if (GetEditorReload(5) == true) {
   LoadTBLList(Form1->UpgLabelList,"stat_txt");
   SetEditorReload(5,false);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
TECHNOLOGY EDITOR
############################################################################
*/

void __fastcall TForm1::TechEditShow(TObject *Sender)
{
if (Form1->TechIconList->Items->Count == 0) {
   LoadList(Form1->TechIconList,"Icons");
}
if (Form1->TechRace->Items->Count == 0) {
   LoadList(Form1->TechRace,"Races");
}
if (GetEditorReload(6) == true) {
   LoadTBLList(Form1->TechLabelList,"stat_txt");
   SetEditorReload(6,false);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
SOUND EDITOR
############################################################################
*/

void __fastcall TForm1::SoundEditShow(TObject *Sender)
{
if (GetEditorReload(7) == true) {
   LoadTBLList(Form1->SoundTBL,"sfxdata");
   SetEditorReload(7,false);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
PORTRAIT EDITOR
############################################################################
*/
void __fastcall TForm1::PortEditShow(TObject *Sender)
{
if (GetEditorReload(8) == true) {
   LoadTBLList(Form1->PortTBL,"portdata");
   SetEditorReload(8,false);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
CAMPAIGN EDITOR
############################################################################
*/

void __fastcall TForm1::MapEditShow(TObject *Sender)
{
if (GetEditorReload(9) == true) {
   LoadTBLList(Form1->MapTBL,"mapdata");
   SetEditorReload(9,false);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
ORDER EDITOR
############################################################################
*/

void __fastcall TForm1::OrderEditShow(TObject *Sender)
{
if (Form1->OrdWeapon->Items->Count == 0) {
   LoadList(Form1->OrdWeapon,"Weapons");
}
if (Form1->OrdTech->Items->Count == 0) {
   LoadList(Form1->OrdTech,"Techdata");
}
if (Form1->OrdEmulate->Items->Count == 0) {
   LoadList(Form1->OrdEmulate,"Orders");
}
if (Form1->OrdAnimation->Items->Count == 0) {
   LoadList(Form1->OrdAnimation,"Animations");
}
if (Form1->OrdHighlightList->Items->Count == 0) {
   LoadList(Form1->OrdHighlightList,"Icons");
}
if (GetEditorReload(10) == true) {
   LoadTBLList(Form1->OrdLabel,"stat_txt");
   SetEditorReload(10,false);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Display the "About" box.
############################################################################
*/
void __fastcall TForm1::AboutClick(TObject *Sender)
{
AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
/*
############################################################################
Display the "Credits" box.
############################################################################
*/
void __fastcall TForm1::CreditsClick(TObject *Sender)
{
CreditsBox->ShowModal();
};
//---------------------------------------------------------------------------
/*
############################################################################
Display the 'Doodads Information' box.
############################################################################
*/

void __fastcall TForm1::DoodadsInfo1Click(TObject *Sender)
{
DoodadInfoBox->ShowModal();
};
//---------------------------------------------------------------------------
/*
############################################################################
Display the Multi-DAT MPQ Export dialog.
############################################################################
*/

void __fastcall TForm1::MPQMultiExportExecute(TObject *Sender)
{
MultiMPQExport->ShowModal();
};
//---------------------------------------------------------------------------
/*
############################################################################
Open the "Load Directory" dialog.
############################################################################
*/

void __fastcall TForm1::OpenDirExecute(TObject *Sender)
{
/*
THIS IS THE ORIGINAL WAY TO GET THE DIRECTORY FROM THE USER,
USING A CUSTOM-MADE "SELECT DIRECTORY" BOX.
*/
OpenDirBox->ShowModal();

/*
THIS IS AN ALTERNATE WAY TO GET THE DIRECTORY, USING THE
"SELECT DIRECTORY" SYSTEM DIALOG BOX. IT IS NOT USED
BECAUSE THE BOX'S SCREEN COORDINATES ARE WEIRD.

String Dir;
SelectDirectory("Select a directory with DAT files to load from:", "",Dir);
if (Dir != "") {
   LoadDATDir(Dir);
}
   */
};
//---------------------------------------------------------------------------
/*
############################################################################
Display the "Open File" box.
############################################################################
*/

void __fastcall TForm1::OpenExecute(TObject *Sender)
{
if (GetLastFolder() != "") {
   OpenDialog->InitialDir = GetLastFolder();
}
OpenDialog->Execute();
};
//---------------------------------------------------------------------------
/*
############################################################################
Activated after a user selects a file for opening using the "Load File"
dialog box. Check for the correct file extension and act appropriately:
if it is a DAT, pass the file over to the parsing routine, if it is an MPQ
 - to the MPQ importing routine, and if it is something different - displays
an error message.
############################################################################
*/

void __fastcall TForm1::OpenDialogCanClose(TObject *Sender,
      bool &CanClose)
{
String LoadExt,LoadFileName;
LoadFileName = OpenDialog->FileName;
LoadExt = ExtractFileExt(LoadFileName).LowerCase();
if (LoadExt != ".dat" && LoadExt != ".mpq") {
    MessageDlg("Unsupported file type. Please choose a DAT or an MPQ file.", mtError, TMsgDlgButtons() << mbOK, 0);
    }
else if (LoadExt == ".dat" || LoadExt == ".mpq") {
    if (FileExists(LoadFileName)) {
       TFileStream* LoadFile = new TFileStream (LoadFileName,fmOpenRead | fmShareDenyNone);
       if (LoadFile != NULL) {
          if (LoadExt == ".dat") {
             for (int i=0;i<11;i++) {
                 if (LoadFile->Size == GetDATSize(i)) {
                    AddHistoryItem(LoadFileName);
                    SetLastFolder(ExtractFileDir(LoadFileName));
                    ClearMPQImportData();
                    CheckDATFile(LoadFileName);
                    break;
                 }
                 else if (i==10){
                    MessageDlg(String("\""+LoadFileName+"\" is not a valid DAT file that DatEdit can recognize."), mtError, TMsgDlgButtons() << mbOK, 0);
                 }
             }
          }
          else if (LoadExt == ".mpq") {
               AddHistoryItem(LoadFileName);
               SetLastFolder(ExtractFileDir(LoadFileName));
               CheckMPQFile(LoadFileName);
          }
       }
       else {
           MessageDlg(String("\""+LoadFileName+"\" cannot be opened."), mtError, TMsgDlgButtons() << mbOK, 0);
       }
       delete LoadFile;
    }
    else {
       MessageDlg("Target file does not exist!", mtError, TMsgDlgButtons() << mbOK, 0);
    }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Activate the saving-to-file routine.
############################################################################
*/

void __fastcall TForm1::SaveExecute(TObject *Sender)
{
SaveDatFile();
}
//---------------------------------------------------------------------------
/*
############################################################################
Open up the "Save As" box.
############################################################################
*/
void __fastcall TForm1::SaveAsExecute(TObject *Sender)
{
if (GetDATObject(GetPage())->GetLoadState() == true) {
    SaveDialog->FileName=(GetDATType(GetPage())+".dat");
    SaveDialog->Execute();
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Carry out the "Saving As" process, after the user selects a file
(or a filename) to save to.
############################################################################
*/
void __fastcall TForm1::SaveDialogCanClose(TObject *Sender, bool &CanClose)
{
String SaveExt,SaveFileName,DATExt;
SaveFileName = SaveDialog->FileName;
SaveExt = ExtractFileExt(SaveFileName);
int DATExist=0;

if (SaveExt != ".dat" && SaveExt != "") {
    MessageDlg("Unsupported file type. Please choose a DAT or an MPQ file.", mtError, TMsgDlgButtons() << mbOK, 0);
    }
else {
    if (SaveExt == "") {
       DATExt = ".dat";
    }
    else if (SaveExt == ".dat") {
       DATExt = "";
    }
    if (FileExists(SaveFileName+DATExt)) {
        if (MessageDlg("Are you sure you want to replace this DAT file?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) {
             DATExist = 1;
        }
    }
    else if (!FileExists(SaveFileName+DATExt)) {
        DATExist = 2;
    }
if (DATExist != 0) {
    GetDATObject(GetPage())->SaveData(SaveFileName+DATExt);
    MessageDlg("File saved succesfully.", mtInformation, TMsgDlgButtons() << mbOK, 0);
    CheckDATFile(SaveFileName+DATExt);
}
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Activate the MPQ-Exporting routine for a single-file export.
############################################################################
*/

void __fastcall TForm1::MPQExportExecute(TObject *Sender)
{
SetMultiDATExport(false);
Form1->MPQSave->Execute();
};
//---------------------------------------------------------------------------
/*
############################################################################
Activate the MPQ-Exporting routine for multi-file export.
############################################################################
*/

void __fastcall TForm1::MPQMultiExportSaveExecute(TObject *Sender)
{
SetMultiDATExport(true);
Form1->MPQSave->Execute();
};
//---------------------------------------------------------------------------
/*
############################################################################
MPQ-exporting routine. Works for both single- and multi-file exporting.
############################################################################
*/
void __fastcall TForm1::MPQSaveCanClose(TObject *Sender, bool &CanClose)
{
String MPQSaveExt,MPQSaveFileName,MPQExt;
MPQSaveFileName = MPQSave->FileName;
MPQSaveExt = ExtractFileExt(MPQSaveFileName);
int MPQExist=0;

if (MPQSaveExt != ".mpq" && MPQSaveExt != "") {
    MessageDlg("Unsupported file type. Please choose an MPQ file.", mtError, TMsgDlgButtons() << mbOK, 0);
    }
else {
    if (MPQSaveExt == "") {
       MPQExt = ".mpq";
    }
    else if (MPQSaveExt == ".mpq") {
       MPQExt = "";
    }
    if (FileExists(MPQSaveFileName+MPQExt)) {
        if (MessageDlg("Are you sure you want to export the DAT file into this MPQ archive?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) {
             MPQExist = 1;
        }
    }
    else if (!FileExists(MPQSaveFileName+MPQExt)) {
        MPQExist = 1;
    }
    if (MPQExist != 0) {
       if (GetMultiDATExport() == false) {
          GetDATObject(GetPage())->SaveData(Form1->GetTempPath()+GetDATType(GetPage())+".dat");
          if (FileExists(Form1->GetTempPath()+GetDATType(GetPage())+".dat")) {
             ExportToMpq(MPQSaveFileName+MPQExt, Form1->GetTempPath()+GetDATType(GetPage())+".dat");
             DeleteFile(Form1->GetTempPath()+GetDATType(GetPage())+".dat");
          }
       }
       else if (GetMultiDATExport() == true) {
            for (int i=0;i<11;i++) {
                if (GetMultiMPQDats(i) == true) {
                     GetDATObject(i)->SaveData(Form1->GetTempPath()+GetDATType(i)+".dat");
                     if (FileExists(Form1->GetTempPath()+GetDATType(i)+".dat")) {
                        ExportToMpq(MPQSaveFileName+MPQExt, Form1->GetTempPath()+GetDATType(i)+".dat");
                        DeleteFile(Form1->GetTempPath()+GetDATType(i)+".dat");
                     }
                }
            }
            for (int i=0;i<5;i++) {
                if (GetMultiMPQTBLs(i) == true) {
                   if (GetTBLIsMPQImport(i) == false) {
                      ExportToMpq(MPQSaveFileName+MPQExt, GetTBL(i));
                   }
                   else {
                      ExportToMpq(MPQSaveFileName+MPQExt, GetMPQTBL(i));
                   }
                }
            }
            if (GetMultiMPQIcons() == true) {
               if (GetIconIsMPQImport() == false) {
                  ExportToMpq(MPQSaveFileName+MPQExt, Icons);
               }
               else {
                  ExportToMpq(MPQSaveFileName+MPQExt, MPQIcons);
               }
            }
       }
    MessageDlg("MPQ Export successful", mtInformation, TMsgDlgButtons() <<mbOK, 0);
    }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
A general purpose routine to perform a jump to a specific DAT's specific
entry from a DAT-pointing property in another DAT file.
############################################################################
*/

void __fastcall TForm1::JumpToDATExecute(TObject *Sender)
{
if (GetDATList(GetPage())->Selected != NULL) {
   int Value=-1,TargetPage;
   switch (GetPage()) {
       case 0:
       if (GetSubPage() == 0) {
          if (Sender == Form1->JumpToGround) {
                 Value = Form1->UnitWeaponGround->Text.ToInt();
                 TargetPage = 1;
          }
          else if (Sender == Form1->JumpToAir) {
                 Value = Form1->UnitWeaponAir->Text.ToInt();
                 TargetPage = 1;
          }
          if (Value == 130) {
                 Value = -1;
          }
       }
       if (GetSubPage() == 2) {
            if (Sender == CheckSndReady) {
                 Value = Form1->UnitSndReady->Text.ToInt()-1;
                 TargetPage=7;
            }
            else if (Sender == CheckSndAnnS) {
                 Value = Form1->UnitSndAnnStart->Text.ToInt()-1;
                 TargetPage=7;
            }
            else if (Sender == CheckSndAnnE) {
                 Value = Form1->UnitSndAnnEnd->Text.ToInt()-1;
                 TargetPage=7;
            }
            else if (Sender == CheckSndWhtS) {
                 Value = Form1->UnitSndWhatStart->Text.ToInt()-1;
                 TargetPage=7;
            }
            else if (Sender == CheckSndWhtE) {
                 Value = Form1->UnitSndWhatEnd->Text.ToInt()-1;
                 TargetPage=7;
            }
            else if (Sender == CheckSndYesS) {
                 Value = Form1->UnitSndYesStart->Text.ToInt()-1;
                 TargetPage=7;
            }
            else if (Sender == CheckSndYesE) {
                 Value = Form1->UnitSndYesEnd->Text.ToInt()-1;
                 TargetPage=7;
            }
       }
       else if (GetSubPage() == 3) {
            if (Sender == Form1->JumpToUnitConstruction) {
                 Value = Form1->UnitConst->ItemIndex;
                 TargetPage=4;
            }
            else if (Sender == Form1->JumpToUnitGfx) {
                 Value = Form1->UnitGfx->ItemIndex;
                 TargetPage=2;
            }
            else if (Sender == Form1->JumpToUnitInfest) {
                 Value = Form1->UnitInfest->ItemIndex;
                 TargetPage=0;
            }
            else if (Sender == Form1->JumpToUnitPort) {
                 Value = Form1->UnitPort->ItemIndex;
                 TargetPage=8;
            }
       }
       else if (GetSubPage() == 5) {
            if (Sender == Form1->JumpToCompIdle) {
                 Value = Form1->UnitAICompIdle->ItemIndex;
                 TargetPage=10;
            }
            else if (Sender == Form1->JumpToHumanIdle) {
                 Value = Form1->UnitAIHumanIdle->ItemIndex;
                 TargetPage=10;
            }
            else if (Sender == Form1->JumpToReturnToIdle) {
                 Value = Form1->UnitAIReturn->ItemIndex;
                 TargetPage=10;
            }
            else if (Sender == Form1->JumpToAttackUnit) {
                 Value = Form1->UnitAIAttackUnit->ItemIndex;
                 TargetPage=10;
            }
            else if (Sender == Form1->JumpToAttackMove) {
                 Value = Form1->UnitAIAttackMove->ItemIndex;
                 TargetPage=10;
            }
       }
            break;
       case 1:
            if (Sender == Form1->JumpToWeapGfx) {
                 Value = Form1->WeapGraphics->Text.ToInt();
                 TargetPage=2;
            }
            else if (Sender == Form1->JumpToWeapUpgrade && Form1->WeapUpgrade->ItemIndex < 61) {
                 Value = Form1->WeapUpgrade->ItemIndex;
                 TargetPage=5;
            }
            break;
       case 2:
            Value = Form1->FlingySprite->Text.ToInt();
            TargetPage=GetPage()+1;
            break;
       case 3:
            Value = Form1->SpriteFile->Text.ToInt();
            TargetPage=GetPage()+1;
            break;
       case 10:
            if (Sender == JumpToOrdWeapon) {
                 Value = Form1->OrdWeapon->ItemIndex;
                 TargetPage=1;
            }
            else if (Sender == JumpToOrdTech) {
                 Value = Form1->OrdTech->ItemIndex;
                 TargetPage=6;
            }
            break;
   }
   if (Value != -1 && Value < GetDATObject(TargetPage)->GetDatacount() && Form1->Editors->Pages[TargetPage]->Enabled == true) {
      Form1->Editors->ActivePageIndex = (TargetPage);
      ChangeTab->Execute();
      if (GetSortingStyle(TargetPage) == 3) {
         GetDATList(TargetPage)->Selected = GetDATList(TargetPage)->Items->Item[Value];
      }
      else if (GetSortingStyle(TargetPage) != 3) {
         GetDATList(TargetPage)->Selected = GetDATList(TargetPage)->Items->Item[LookEntry(Value,TargetPage)];
      }
   }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Perform a jump to the appropriate entry ID of the currently displayed
editor. The value is read from the JumpToId text box in the right-hand
side lower corner of the application window.
It is universal and works for all editors.

Security checks:
-works only if the ENTER key was pressed
-the typed value must be positive
-the typed value must be lower or equal to the number of items in the currently
used list
-the currently used listing is filled (it is not empty)
-the listing panel is active (enabled).
(the last one requires a word of explanation: elsewhere in the code
you will find it that the listing panel is only activated when
a DAT file has been opened for the currently used editor, otherwise
it is deactivated. In this context, this check ensures that there
is data we can jump to)
############################################################################
*/

void __fastcall TForm1::JumpToIDKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
if (Key == VK_RETURN) {
   if (JumpToID->Text.ToInt() < GetDATList(GetPage())->Items->Count && (JumpToID->Text.IsEmpty() == false) && (GetDATList(GetPage())->Items->Count != 0) && Form1->ElGrandoListos->Enabled == true && JumpToID->Text.ToInt() >= 0) {
      JumpToID->Color = clBlack;
      ChangeTab->Execute();
      if (GetSortingStyle(GetPage()) == 3) {
         GetDATList(GetPage())->Selected = GetDATList(GetPage())->Items->Item[JumpToID->Text.ToInt()];
      }
      else if (GetSortingStyle(GetPage()) != 3) {
         GetDATList(GetPage())->Selected = GetDATList(GetPage())->Items->Item[LookEntry(JumpToID->Text.ToInt(),GetPage())];
      }
   }
   else {
     JumpToID->Color = clRed;
   }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Input 0 to the textboxes that the user left with no value in them.
A security countermeasure, if you want to think of it like that.

It is used by all textboxes (aka Edit boxes) in DatEdit. 
############################################################################
*/
void __fastcall TForm1::ExitEditExecute(TObject *Sender)
{
if (((TEdit*) Sender)->Text.IsEmpty() == true) {
   ((TEdit*) Sender)->Text = 0;
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Activated when the content of a text box has changed and passes
the changes over to a specific function that applies the changes to the
data stored in the memory.

Works only if an entry has been previously selected (to avoid errors
if you try to alter the content with no entry selected, what happened
in the pre-0.94 versions).

Used by all text/Edit boxes in DatEdit.
############################################################################
*/

void __fastcall TForm1::ChangeEditExecute(TObject *Sender)
{
if (((TEdit*)(Sender))->Text.IsEmpty() == false && GetDATList(GetPage())->Selected != NULL) {
   int value = ((TEdit*) Sender)->Text.ToInt();
   for (unsigned int i=0;i<GetDATList(GetPage())->SelectionCount;i++) {
       int NodeID = GetDATList(GetPage())->Selections[i]->ImageIndex;
       if (NodeID != -1) {
          switch (GetPage()) {
            case 0:
                 ChangeUnitData(value,NodeID,Sender);
                 break;
            case 1:
                 ChangeWeaponData(value,NodeID,Sender);
                 break;
            case 2:
                 ChangeFlingyData(value,NodeID,Sender);
                 break;
            case 3:
		 ChangeSpriteData(value,NodeID,Sender);
                 break;
            case 4:
                 ChangeImageData(value,NodeID,Sender);
                 break;
            case 5:
		 ChangeUpgradeData(value,NodeID,Sender);
                 break;
            case 6:
		 ChangeTechData(value,NodeID,Sender);
                 break;
            case 7:
		 ChangeSoundData(value,NodeID,Sender);
                 break;
            case 8:
		 ChangePortData(value,NodeID,Sender);
		 break;
            case 9:
                 ChangeMapData(value,NodeID,Sender);
                 break;
            case 10:
		 ChangeOrderData(value,NodeID,Sender);
                 break;
          }
       }
   }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Does the same as the above one, but for the dropdown boxes (also know as
"combo boxes").

Used by all combo boxes in DatEdit.
############################################################################
*/

void __fastcall TForm1::ChangeComboExecute(TObject *Sender)
{
if (GetDATList(GetPage())->Selected != NULL) {
   int value = ((TComboBox*) Sender)->ItemIndex;
   for (unsigned int  i=0;i<GetDATList(GetPage())->SelectionCount;i++) {
       int NodeID = GetDATList(GetPage())->Selections[i]->ImageIndex;
       if (NodeID != -1) {
          switch (GetPage()) {
            case 0:
 		 ChangeUnitData(value,NodeID,Sender);
                 break;
            case 1:
                 ChangeWeaponData(value,NodeID,Sender);
                 break;
            case 2:
		 ChangeFlingyData(value,NodeID,Sender);
                 break;
            case 3:
                 ChangeSpriteData(value,NodeID,Sender);
                 break;
            case 4:
                 ChangeImageData(value,NodeID,Sender);
                 break;
            case 5:
		 ChangeUpgradeData(value,NodeID,Sender);
                 break;
            case 6:
		 ChangeTechData(value,NodeID,Sender);
                 break;
            case 7:
                 ChangeSoundData(value,NodeID,Sender);
		 break;
            case 8:
		 ChangePortData(value,NodeID,Sender);
                 break;
            case 9:
		 ChangeMapData(value,NodeID,Sender);
                 break;
            case 10:
		 ChangeOrderData(value,NodeID,Sender);
                 break;
          }
       }
   }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Same as the above two, but activated for the checkboxes.

Used by all checkboxes in DatEdit.
############################################################################
*/

void __fastcall TForm1::ChangeCheckBoxExecute(TObject *Sender)
{
if (GetDATList(GetPage())->Selected != NULL) {
   int value = int (((TCheckBox*) Sender)->Checked);
   for (unsigned int i=0;i<GetDATList(GetPage())->SelectionCount;i++) {
       int NodeID = GetDATList(GetPage())->Selections[i]->ImageIndex;
       if (NodeID != -1) {
          switch (GetPage()) {
            case 0:
		 ChangeUnitData(value,NodeID,Sender);
                 break;
            case 1:
                 ChangeWeaponData(value,NodeID,Sender);
		 break;
            case 2:
                 ChangeFlingyData(value,NodeID,Sender);
		 break;
            case 3:
                 ChangeSpriteData(value,NodeID,Sender);
                 break;
            case 4:
                 ChangeImageData(value,NodeID,Sender);
                 break;
            case 5:
		 ChangeUpgradeData(value,NodeID,Sender);
                 break;
            case 6:
		 ChangeTechData(value,NodeID,Sender);
		 break;
	    case 7:
		 ChangeSoundData(value,NodeID,Sender);
		 break;
	    case 8:
		 ChangePortData(value,NodeID,Sender);
		 break;
	    case 9:
		 ChangeMapData(value,NodeID,Sender);
		 break;
	    case 10:
		 ChangeOrderData(value,NodeID,Sender);
		 break;
          }
       }
   }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Run the routine above, but for the properties that stored as flags in
the file data. It is implemented as a separate routine because the
changes of the flag-checkboxes and of the boolean-variable-checkboxes
are triggered by different BCB events.
############################################################################
*/

void __fastcall TForm1::FlagToggler(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
ChangeCheckBoxExecute(Sender);
};
//---------------------------------------------------------------------------
/*
############################################################################
Activate the routine responsible for the 'Copy Entry' action.
############################################################################
*/

void __fastcall TForm1::CopyExecute(TObject *Sender)
{
if (GetDATList(GetPage())->Selected != NULL) {
   GetDATObject(GetPage())->CopyTempEntry(GetDATList(GetPage())->Selected->ImageIndex);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Activates the routine responsible for the 'Paste Entry' action.
############################################################################
*/

void __fastcall TForm1::PasteExecute(TObject *Sender)
{
if (GetDATList(GetPage())->Selected != NULL) {
   GetDATObject(GetPage())->PasteTempEntry(GetDATList(GetPage())->Selected->ImageIndex);
   ChangeTab->Execute();
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Activate the routine responsible for the 'Copy Tab' action.
############################################################################
*/

void __fastcall TForm1::CopyTabExecute(TObject *Sender)
{
if (GetDATList(GetPage())->Selected != NULL) {
   GetDATObject(GetPage())->CopyTab(GetDATList(GetPage())->Selected->ImageIndex,GetSubPage());
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Activate the routine responsible for the 'Paste Tab' action.
############################################################################
*/

void __fastcall TForm1::PasteTabExecute(TObject *Sender)
{
if (GetDATList(GetPage())->Selected != NULL) {
   GetDATObject(GetPage())->PasteTab(GetDATList(GetPage())->Selected->ImageIndex,GetSubPage());
   ChangeTab->Execute();
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Activate the routine responsible for the 'Paste Mixed' action.
############################################################################
*/

void __fastcall TForm1::PasteMixedExecute(TObject *Sender)
{
if (GetDATList(GetPage())->Selected != NULL) {
   GetDATObject(GetPage())->PasteMix(GetDATList(GetPage())->Selected->ImageIndex);
   ChangeTab->Execute();
}
};
//---------------------------------------------------------------------------
/*
############################################################################
This used to be a very important routine, but because of problems with
right-clicking its code was moved to the very next routine (ListMouseUp),
which this one calls instead of "doing all the job" itself.
In case there is no node selected for the currently used entry listing
(which happens only the first time an editor is being opened) the first
node is selected (coordinates X-0,Y-0), otherwise the appropriate entry
is activated (its coordinates are taken from the selection rectangle, which
is a property of TTreeNode-type component). 
############################################################################
*/

void __fastcall TForm1::ListChange(TObject *Sender, TTreeNode *Node)
{
if (Node == NULL) {
   GetDATList(GetPage())->OnMouseUp(Sender,mbLeft,TShiftState() <<ssShift,0,0);
}
else {
   GetDATList(GetPage())->OnMouseUp(Sender,mbLeft,TShiftState() <<ssShift,Node->DisplayRect(true).left,Node->DisplayRect(true).top);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
An important one, this routine controls the display of the appropriate data
for the selected entry, as well as of its entry ID in the right-hand lower
corner of the application window. It also runs the Backward-Reporting routine.

You may be surprised that the "ImageIndex" property is being used as entry
index here, but here is the explanation - since the TTreeNode items does
not possess the 'Tag' property to store its Starcraft ID, the ImageIndex
property is used for this purpose. It's only an integer value that has to
be stored somewhere, and this property was chosen because it is not used
in the program at all. Simple as that.
############################################################################
*/

void __fastcall TForm1::ListMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (Button == mbLeft || Button == mbRight) {
   if (GetDATList(GetPage())->Selected != NULL) {
      TTreeNode *Node = GetDATList(GetPage())->Selected;
      Node->Selected = true;
      if (Node->ImageIndex == -1) {
            Form1->ID->Text = "";
      }
      else if (Node->ImageIndex != -1) {
         DisplayEntryData(Node->ImageIndex,Form1->Editors->ActivePageIndex);
         Form1->ID->Text = (String(Node->ImageIndex));
         if (GetPage() >=1 && GetPage() <=6 && OptionsBox->UseBackwardReporting->Checked == true) {
            LoadUsedList(GetPage(),Node->ImageIndex);
         }
         if (OptionsBox->UseBackwardReporting->Checked == false) {
              Form1->UsedList->Clear();
         }
      }
   }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
This routine controls the display the proper list for a specific editor.
If you wanna know, there are as many lists as there are editors, 11 of them,
and this routine displays only the one used by the currently active editor,
hiding the rest. It also makes sure that after a tab has changed,
an update to the displayed data takes place.
############################################################################
*/

void __fastcall TForm1::ChangeTabExecute(TObject *Sender)
{
SetPage(Form1->Editors->ActivePage->PageIndex);
if (GetDATObject(GetPage())->GetLoadState() == false || !(FileExists(GetDATObject(GetPage())->GetDatName()))) {
   CheckDATFile((GetProgPath())+"default\\"+GetDATType(GetPage())+".dat");
}

if (GetSortingStyle(GetPage()) != 3) {
   GetDATList(GetPage())->MultiSelect = false;
}
else if (GetSortingStyle(GetPage()) == 3) {
   GetDATList(GetPage())->MultiSelect = true;
}

CheckSortingStyle(GetSortingStyle(GetPage()), GetPage());
for (int i=0;i<11;i++) {
    if (i == GetPage()) {
       GetDATList(i)->Show();
    }
    else {
       GetDATList(i)->Hide();
    }
}

if (GetPage()>=1 && GetPage()<=6) {
    Form1->LabelUsed->Visible = true;
    Form1->UsedList->Visible = true;
    switch (GetPage()) {
           case 1:
                break;
           case 2:
                break;
           case 3:
                if (Editors->Pages[2]->TabVisible == false) {
                   Form1->LabelUsed->Visible = false;
                   Form1->UsedList->Visible = false;
                }
                break;
           case 4:
                if (Editors->Pages[3]->TabVisible == false) {
                   Form1->LabelUsed->Visible = false;
                   Form1->UsedList->Visible = false;
                }
                break;
           case 5:
                break;
           case 6:
                break;
    }
}
else {
    Form1->LabelUsed->Visible = false;
    Form1->UsedList->Visible = false;
}
Form1->StatusBar->Panels->Items[0]->Text = GetDATObject(GetPage())->GetDatName();
if (GetDATList(GetPage())->Selected != NULL) {
   Form1->ListChange(GetDATList(GetPage()),GetDATList(GetPage())->Selected);
}
else {
   Form1->UsedList->Items->Clear();
}
if (Form1->Visible == true) {
   GetDATList(GetPage())->SetFocus();
}
};
//--------------------------------------------------------------------------
/*
############################################################################
Update the displayed data within the Units Editor subtabs only.
############################################################################
*/
void __fastcall TForm1::UnitTabsChange(TObject *Sender)
{
SetSubPage(UnitTabs->ActivePageIndex);
if (GetDATList(0)->Selected != NULL) {
   Form1->ListChange(GetDATList(0),GetDATList(0)->Selected);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Activated by a double-click, this routine is responsible for jumping from
the 'Used By' box to the appropriate entry of the appropriate DAT file.
############################################################################
*/

void __fastcall TForm1::UsedListDblClick(TObject *Sender)
{
   String SelectedItem = Form1->UsedList->Items->Strings[Form1->UsedList->ItemIndex];
   int Start = SelectedItem.Pos("[");
   int End = SelectedItem.Pos("]");
   char Type = SelectedItem[Start+1];
   String Value = SelectedItem.SubString(Start+2,End-Start-2);

   int TargetPageID;
   switch (Type) {
   	case 'F':
        	TargetPageID = 2;
                break;
        case 'S':
        	TargetPageID = 3;
                break;
        case 'I':
                TargetPageID = 4;
                break; 
        case 'U':
        	TargetPageID = 0;
                break;
        case 'W':
        	TargetPageID = 1;
                break;
        case 'O':
        	TargetPageID = 10;
                break;
   }

   if (Editors->Pages[TargetPageID]->Enabled == true && (GetDATList(TargetPageID))->Enabled == true) {
      Form1->Editors->ActivePageIndex = TargetPageID;
      if (GetSortingStyle(TargetPageID) == 3) {
         GetDATList(TargetPageID)->Selected = GetDATList(TargetPageID)->Items->Item[Value.ToInt()];
      }
      else if (GetSortingStyle(TargetPageID) != 3) {
         GetDATList(TargetPageID)->Selected = GetDATList(TargetPageID)->Items->Item[LookEntry(Value.ToInt(),TargetPageID)];
      }
      ChangeTab->Execute();
   }
   else {
    	MessageDlg("Jump to the target editor is impossible.", mtError, TMsgDlgButtons() << mbOK, 0);
   }
};
//---------------------------------------------------------------------------
/*
############################################################################
This routine controls which items from the 'Edit' menu are available.
It detects which editor is currently loaded, and whether an entry (or a tab)
has been previously Copied (clearly, activating the 'Paste' options)
############################################################################
*/

void __fastcall TForm1::EditMenuClick(TObject *Sender)
{
Form1->Copy1->Enabled = true;
Form1->Paste1->Enabled = true;
Form1->CopyTab1->Enabled = true;
Form1->PasteTab1->Enabled = true;
Form1->PasteMixed1->Enabled = true;

if (GetPage() != 0) {
     Form1->CopyTab1->Enabled = false;
     Form1->PasteTab1->Enabled = false;
     Form1->PasteMixed1->Enabled = false;
}
if (GetDATList(GetPage())->Selected == NULL) {
     Form1->Copy1->Enabled = false;
     Form1->Paste1->Enabled = false;
     Form1->CopyTab1->Enabled = false;
     Form1->PasteTab1->Enabled = false;
     Form1->PasteMixed1->Enabled = false;
}
if (GetTempDats(GetPage()) == false) {
     Form1->Paste1->Enabled = false;
     if (GetPage() == 0) {
          Form1->PasteMixed1->Enabled = false;
     }
}
if (GetTempTabs(GetSubPage()) == false) {
     Form1->PasteTab1->Enabled = false;
}
};
//---------------------------------------------------------------------------
/*
############################################################################
This routine detects if there are any items in the File History, and if so
displays a nice information about this fact =).
############################################################################
*/

void __fastcall TForm1::FileMenuClick(TObject *Sender)
{
if (Form1->MRUD->Count == 0) {
   TMenuItem *Dummy = new TMenuItem(Form1);
   Dummy->Caption = "<No files in History>";
   Form1->MRUD->Add(Dummy);
   Dummy->Enabled = false;
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Load an appropriate DAT file from the File History after it has been
clicked.
############################################################################
*/

void __fastcall TForm1::LoadHistoryItemExecute(TObject *Sender)
{
String FileName = ((TMenuItem*)(Sender))->Caption;
String FileExt = ExtractFileExt(FileName).LowerCase();
if (FileExt == ".dat") {
   ClearMPQImportData();
   CheckDATFile(FileName);
}
else if (FileExt == ".mpq") {
   CheckMPQFile(FileName);
}
else if (FileExt == "") {
   LoadDATDir(FileName);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Clears the File History.
############################################################################
*/

void __fastcall TForm1::ClearHistoryClick(TObject *Sender)
{
Form1->MRUD->Clear();
};
//---------------------------------------------------------------------------
/*
############################################################################
On/Off control of displaying the Unit Size Preview.
############################################################################
*/

void __fastcall TForm1::ShowUnitSizePreviewClick(TObject *Sender)
{
Form1->SizeRect->Visible = OptionsBox->ShowUnitSizePreview->Checked;
Form1->SizeRefPoint->Visible = OptionsBox->ShowUnitSizePreview->Checked;
if (Form1->SizeRect->Visible == true) {
   int EntryID = GetDATList(0)->Selected->Index;
   DrawUnitSize(GetDATObject(0)->GetData()[EntryID*GetDATObject(0)->GetOffcount()+38],GetDATObject(0)->GetData()[EntryID*GetDATObject(0)->GetOffcount()+39]);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Opens up the Options box.
############################################################################
*/
void __fastcall TForm1::OptionsClick(TObject *Sender)
{
OptionsBox->ShowModal();
};
//---------------------------------------------------------------------------
/*
############################################################################
Clears out the File History.
############################################################################
*/
void __fastcall TForm1::ClearHistoryExecute(TObject *Sender)
{
Form1->MRUD->Clear();
};
//---------------------------------------------------------------------------
/*
############################################################################
Reads the config file - DatEdit.ini - for fundamental properties: History
List, application window size, starting editor and the TBL paths.
############################################################################
*/

void __fastcall TForm1::ReadConfigExecute(TObject *Sender)
{
if (FileExists(GetProgPath()+"DatEdit.ini")) {
   TIniFile *ConfigIni = new TIniFile(GetProgPath()+"DatEdit.ini");

   if (ConfigIni->SectionExists("Recently Used") && ConfigIni->ReadInteger("Recently Used","History Items",0) > 0) {

      if (ConfigIni->ReadInteger("Recently Used","History Items",0) == 0) {
          TMenuItem *Dummy = new TMenuItem(Form1);
          Dummy->Caption = "<No files in History>";
          Form1->MRUD->Add(Dummy);
          Dummy->Enabled = false;
      }
      else {
          for (int i=ConfigIni->ReadInteger("Recently Used","History Items",0);i>=1;i--) {
                TMenuItem *NewHistoryItem = new TMenuItem(Form1);
                NewHistoryItem->Caption = ConfigIni->ReadString("Recently Used","File"+String(i),"");
                NewHistoryItem->OnClick = LoadHistoryItemExecute;
                Form1->MRUD->Insert(0,NewHistoryItem);
          }
      }
   }
   if (ConfigIni->ReadInteger("UserSize","UserWidth",0) != 0) {
      Form1->Width = ConfigIni->ReadInteger("UserSize","UserWidth",0);
   }
   if (ConfigIni->ReadInteger("UserSize","UserHeight",0) != 0) {
      Form1->Height = ConfigIni->ReadInteger("UserSize","UserHeight",0);
   }
   SetStartEditor(ConfigIni->ReadInteger("Options","StartEditor",0));
   SetLastFolder(ConfigIni->ReadString("Last Opened","Folder",""));
   SetTBL(0,ConfigIni->ReadString("TBLs","Stat_txt",""));
   SetTBL(1,ConfigIni->ReadString("TBLs","Images",""));
   SetTBL(2,ConfigIni->ReadString("TBLs","Portdata",""));
   SetTBL(3,ConfigIni->ReadString("TBLs","Sfxdata",""));
   SetTBL(4,ConfigIni->ReadString("TBLs","Mapdata",""));
   switch (ConfigIni->ReadInteger("Options","Window",0)) {
       case 0:
            Form1->WindowState = wsNormal;
            break;
       case 1:
            Form1->WindowState = wsMaximized;
            break;
       case 2:
            Form1->WindowState = wsMinimized;
            break;
   }
   for (int i=0;i<11;i++) {
       if (ConfigIni->SectionExists(String(GetDATType(i)+" Bookmarks")) == false) {
          continue;
       }
       else {
          for (int j=0;;j++) {
              String Text = ConfigIni->ReadString(String(GetDATType(i)+" Bookmarks"),"Item"+String(j+1),"");
              if (Text == "") {
                 break;
              }
              else {
                   TMenuItem *Dummy = new TMenuItem(Form1);
                   Dummy->Caption = Text;
                   Dummy->Visible = true;
                   Dummy->OnClick = BookmarkClickExecute;
                   int OpenBracketPos = Dummy->Caption.Pos("[");
                   int CloseBracketPos = Dummy->Caption.Pos("]");
                   int Value = Dummy->Caption.SubString(2,CloseBracketPos-OpenBracketPos-1).ToInt();
                   Dummy->Tag = Value;
                   Bookmarks->Items[i]->Insert(Bookmarks->Items[i]->Count,Dummy);
              }
          }
       }
   }
   delete ConfigIni;
}
else {
   MessageDlg("The \"DatEdit.ini\" config file was not found. DatEdit will use the default options.", mtInformation, TMsgDlgButtons() << mbOK, 0);
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Saves out the basic stuff to DatEdit.ini.
############################################################################
*/

void __fastcall TForm1::SaveConfigExecute(TObject *Sender)
{
TIniFile *ConfigIni = new TIniFile(GetProgPath()+"DatEdit.ini");

ConfigIni->WriteInteger("UserSize","UserWidth",Form1->Width);
ConfigIni->WriteInteger("UserSize","UserHeight",Form1->Height);
ConfigIni->WriteInteger("Sorting","Units Editor",TabSortingStyle[0]);
ConfigIni->WriteInteger("Sorting","Weapons Editor",TabSortingStyle[1]);
ConfigIni->WriteInteger("Sorting","Upgrades Editor",TabSortingStyle[5]);
ConfigIni->WriteInteger("Sorting","Techs Editor",TabSortingStyle[6]);
ConfigIni->WriteString("Last Opened","Folder",GetLastFolder());
if (Form1->WindowState == wsNormal) {
   ConfigIni->WriteInteger("Options","Window",0);
}
else if (Form1->WindowState == wsMaximized) {
   ConfigIni->WriteInteger("Options","Window",1);
}
else if (Form1->WindowState == wsMinimized) {
   ConfigIni->WriteInteger("Options","Window",2);
}

ConfigIni->EraseSection("Recently Used");
if (Form1->MRUD->Count == 0) {
    ConfigIni->WriteInteger("Recently Used","History Items",0);
}
else if (Form1->MRUD->Count != 0) {
    if (Form1->MRUD->Items[0]->Caption.Pos("<") == 0) {
       ConfigIni->WriteInteger("Recently Used","History Items",Form1->MRUD->Count);
    }
    for (int i=0;i<Form1->MRUD->Count;i++) {
        if (Form1->MRUD->Items[i]->Caption.Pos("<") != 0)  {
           ConfigIni->WriteInteger("Recently Used","History Items",0);
           break;
        }
        if (Form1->MRUD->Items[i]->Caption == "") {
           continue;
        }
        ConfigIni->WriteString("Recently Used",String("File"+String(i+1)),Form1->MRUD->Items[i]->Caption);
    }
}
for (int i=0;i<11;i++) {
    ConfigIni->EraseSection(GetDATType(i)+" Bookmarks");
    for (int j=0;j<Bookmarks->Items[i]->Count;j++) {
        ConfigIni->WriteString(GetDATType(i)+" Bookmarks",String("Item"+String(j+1)),Bookmarks->Items[i]->Items[j]->Caption);
    }
}
delete ConfigIni;
};
//---------------------------------------------------------------------------
/*
############################################################################
Read DatEdit.ini for the Options-related properties: exit confirmation
backward reporting, unit size preview display and again - the TBLs.
############################################################################
*/

void __fastcall TForm1::ReadConfigOptionsExecute(TObject *Sender)
{
TIniFile *ConfigIni = new TIniFile(GetProgPath()+"DatEdit.ini");
if (ConfigIni->SectionExists("Options")) {
      OptionsBox->ConfirmOnExit->Checked = ConfigIni->ReadBool("Options","ConfirmOnExit",true);
      OptionsBox->UseBackwardReporting->Checked= ConfigIni->ReadBool("Options","UseBackwardReporting",true);
      OptionsBox->ShowUnitSizePreview->Checked = ConfigIni->ReadBool("Options","ShowUnitSizePreview",true);
      OptionsBox->ShowHints->Checked = ConfigIni->ReadBool("Options","ShowHints",true);
      OptionsBox->ShowSplash->Checked = ConfigIni->ReadBool("Options","ShowSplash",true);
      OptionsBox->UseCustomNames->Checked = ConfigIni->ReadBool("Options","UseCustomNames",false);
      SetUseCustomNames(ConfigIni->ReadBool("Options","UseCustomNames",false));
      OptionsBox->StartEditor->ItemIndex = ConfigIni->ReadInteger("Options","StartEditor",0);
}
if (ConfigIni->SectionExists("TBLs")) {
      OptionsBox->StatPath->Text = ConfigIni->ReadString("TBLs","Stat_txt","");
      OptionsBox->ImagesPath->Text = ConfigIni->ReadString("TBLs","Images","");
      OptionsBox->PortdataPath->Text = ConfigIni->ReadString("TBLs","Portdata","");
      OptionsBox->SfxPath->Text = ConfigIni->ReadString("TBLs","Sfxdata","");
      OptionsBox->MapdataPath->Text = ConfigIni->ReadString("TBLs","Mapdata","");

      SetTBL(0,ConfigIni->ReadString("TBLs","Stat_txt",""));
      SetTBL(1,ConfigIni->ReadString("TBLs","Images",""));
      SetTBL(2,ConfigIni->ReadString("TBLs","Portdata",""));
      SetTBL(3,ConfigIni->ReadString("TBLs","Sfxdata",""));
      SetTBL(4,ConfigIni->ReadString("TBLs","Mapdata",""));
}
else {
      OptionsBox->StatPath->Text = (GetProgPath()+"default\\stat_txt.tbl");
      OptionsBox->ImagesPath->Text = (GetProgPath()+"default\\images.tbl");
      OptionsBox->PortdataPath->Text = (GetProgPath()+"default\\portdata.tbl");
      OptionsBox->SfxPath->Text = (GetProgPath()+"default\\sfxdata.tbl");
      OptionsBox->MapdataPath->Text = (GetProgPath()+"default\\mapdata.tbl");

      SetTBL(0,GetProgPath()+"default\\stat_txt.tbl");
      SetTBL(1,GetProgPath()+"default\\images.tbl");
      SetTBL(2,GetProgPath()+"default\\portdata.tbl");
      SetTBL(3,GetProgPath()+"default\\sfxdata.tbl");
      SetTBL(4,GetProgPath()+"default\\mapdata.tbl");
}
if (ConfigIni->SectionExists("Icons")) {
      OptionsBox->IconsPath->Text = ConfigIni->ReadString("Icons","File","");
      SetIcons(ConfigIni->ReadString("Icons","File",""));
}
else {
      OptionsBox->IconsPath->Text = (GetProgPath()+"default\\cmdicons.grp");
      SetIcons(GetProgPath()+"default\\cmdicons.grp");
}
delete ConfigIni;
};
//---------------------------------------------------------------------------
/*
############################################################################
Saves out the Options-related stuff to DatEdit.ini.
############################################################################
*/

void __fastcall TForm1::SaveConfigOptionsExecute(TObject *Sender)
{
TIniFile *ConfigIni = new TIniFile(GetProgPath()+"DatEdit.ini");
ConfigIni->WriteBool("Options","ConfirmOnExit",OptionsBox->ConfirmOnExit->Checked);
ConfigIni->WriteBool("Options","UseBackwardReporting",OptionsBox->UseBackwardReporting->Checked);
ConfigIni->WriteBool("Options","ShowUnitSizePreview",OptionsBox->ShowUnitSizePreview->Checked);
ConfigIni->WriteBool("Options","ShowHints",OptionsBox->ShowHints->Checked);
ConfigIni->WriteBool("Options","ShowSplash",OptionsBox->ShowSplash->Checked);
ConfigIni->WriteBool("Options","UseCustomNames",OptionsBox->UseCustomNames->Checked);
ConfigIni->WriteInteger("Options","StartEditor",OptionsBox->StartEditor->ItemIndex);

ConfigIni->WriteString("TBLs","Stat_txt",GetTBL(0));
ConfigIni->WriteString("TBLs","Images",GetTBL(1));
ConfigIni->WriteString("TBLs","Portdata",GetTBL(2));
ConfigIni->WriteString("TBLs","Sfxdata",GetTBL(3));
ConfigIni->WriteString("TBLs","Mapdata",GetTBL(4));
ConfigIni->WriteString("Icons","File",GetIcons());

delete ConfigIni;
};
//---------------------------------------------------------------------------
/*
############################################################################
Controls which Sorting methods are available in which Editor.
############################################################################
*/

void __fastcall TForm1::ViewMenuClick(TObject *Sender)
{
if ((GetPage() >= 2 && GetPage() <=4) || GetPage() >=7) {
    Form1->SortbyData->Enabled = false;
    Form1->SortbyData->Checked = false;
    Form1->SortbyOrigin->Enabled = false;
    Form1->SortbyOrigin->Checked = false;
}
else if (GetPage() == 5 || GetPage() == 6) {
    Form1->SortbyData->Enabled = true;
    Form1->SortbyOrigin->Enabled = true;
}
else if (GetPage() == 1) {
    Form1->SortbyOrigin->Enabled = true;
    Form1->SortbyData->Enabled = false;
    Form1->SortbyData->Checked = false;
}
else if (GetPage() == 0) {
    Form1->SortbyData->Enabled = true;
    Form1->SortbyOrigin->Enabled = true;
}
ViewMenu->Items[GetSortingStyle(GetPage())]->Checked = true;
};
//---------------------------------------------------------------------------
/*
############################################################################
Controls the sorting selection events - it also makes the current Editor
reload.
############################################################################
*/

void __fastcall TForm1::SetSortingExecute(TObject *Sender)
{
if (GetPage() < 2 || GetPage() == 5 || GetPage() == 6) {
   if (((TMenuItem*)(Sender))->MenuIndex != GetSortingStyle(GetPage())) {
      ((TMenuItem*)(Sender))->Checked = !((TMenuItem*)(Sender))->Checked;
      SetSortingStyle(GetPage(),((TMenuItem*)(Sender))->MenuIndex);
   }
   Form1->SetListReload(GetPage(),true);
   ChangeTab->Execute();
}
};
//---------------------------------------------------------------------------
/*
############################################################################
This routine activates the hint-loading routine. It is used as an "OnEnter"
event, so it will take place only after specific controls receives focus.
############################################################################
*/
void __fastcall TForm1::LoadHintExecute(TObject *Sender)
{
if (OptionsBox->ShowHints->Checked == true) {
   LoadHints(Sender);
}
else
    InfoText->Text = "";
};
//---------------------------------------------------------------------------
/*
############################################################################
Activated by the click on the "Search" button, this routine launches the
list-searching function.
############################################################################
*/

void __fastcall TForm1::SearchTextKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
if (Key == VK_RETURN && SearchText->Text.IsEmpty() == false) {
   bool InList=false;
   for (int i=0;i<=SearchText->Items->Count;i++) {
       if (SearchText->Items->Strings[i].AnsiCompareIC(SearchText->Text) == 0) {
           InList=true;
           break;
       }
   }
   if (InList == false) {
       SearchText->Items->Add(SearchText->Text);
   }
   SearchList->Execute();
}
};
//---------------------------------------------------------------------------
/*
############################################################################
The list-searching function. Simple yet very effective. You may wonder
about the use of the "Tag" property near the end of it - it is used to
determine whether an entry has already been found in the list (value 0)
when the list-parsing loop finishes the search. If an entry has been
found - it will search the list again and find it. If there was no entry
found - it will exit the loop.
############################################################################
*/

void __fastcall TForm1::SearchListExecute(TObject *Sender)
{
int Index=0;
SearchText->Tag = 0;
if (GetDATList(GetPage())->Selected == NULL) {
   Index = 0;
}
else if (GetDATList(GetPage())->Selected != NULL) {
   if (GetDATList(GetPage())->Selected->AbsoluteIndex == GetDATList(GetPage())->Items->Count-1) {
      Index = 0;
   }
   else
      Index = GetDATList(GetPage())->Selected->AbsoluteIndex+1;
}
for (int i=Index;i<GetDATList(GetPage())->Items->Count;i++) {
   if ((GetDATList(GetPage())->Items->Item[i]->Text.LowerCase()).Pos(SearchText->Text.LowerCase()) != 0) {
       GetDATList(GetPage())->Selected = GetDATList(GetPage())->Items->Item[i];
       SearchText->Tag = 0;
       break;
   }
   if (i>=GetDATList(GetPage())->Items->Count-1) {
       if (SearchText->Tag == 1) {
          break;
       }
       else if (SearchText->Tag != 1) {
          i=0;
          SearchText->Tag = 1;
       }
   }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Reloads the editor with an appropriate default DAT.
############################################################################
*/

void __fastcall TForm1::ReloadDefaultExecute(TObject *Sender)
{
CheckDATFile(GetProgPath()+"default\\"+GetDATType(Form1->GetPage())+".dat");
};
//---------------------------------------------------------------------------
/*
############################################################################
Flush back the DATs imported from an MPQ archive.Clear the importing info.
############################################################################
*/

void __fastcall TForm1::MPQReturnExportExecute(TObject *Sender)
{
bool ExportFound=false;
if (GetMPQName() == "") {
    MessageDlg("No MPQ-imported DAT files found!", mtError, TMsgDlgButtons() << mbOK, 0);
}
else {
    for (int i=0;i<11;i++) {
    	if (GetDATObject(i)->GetIsMPQImport() == true) {
           GetDATObject(i)->SaveData(Form1->GetTempPath()+GetDATType(i)+".dat");
           if (FileExists(Form1->GetTempPath()+GetDATType(i)+".dat")) {
              ExportToMpq(GetMPQName(), Form1->GetTempPath()+GetDATType(i)+".dat");
              DeleteFile(Form1->GetTempPath()+GetDATType(i)+".dat");
           }
           ExportFound = true;
        }
    }
    if (ExportFound == true) {
    	MessageDlg("Return MPQ-Export successfull.", mtInformation, TMsgDlgButtons() << mbOK, 0);
        ClearMPQImportData();
    }
    else if (ExportFound == false) {
    	MessageDlg("No MPQ-imported DAT files found!", mtError, TMsgDlgButtons() << mbOK, 0);
    }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Control which options are available for the right-click popup menu.
############################################################################
*/

void __fastcall TForm1::PopupMenuPopup(TObject *Sender)
{
(GetDATList(GetPage())->Selected)->Selected = true;

PasteEntry1->Enabled = true;
if (GetTempDats(GetPage()) == false) {
   PasteEntry1->Enabled = false;
}

QuickBM->Clear();
if (Bookmarks->Items[GetPage()]->Count == 0) {
   QuickBM->Visible = false;
}
else {
   QuickBM->Visible = true;
   for (int i=0;i<Bookmarks->Items[GetPage()]->Count;i++) {
       TMenuItem *Dummy = new TMenuItem(PopupMenu);
       Dummy->Visible = true;
       Dummy->OnClick = QuickBMClickExecute;
       Dummy->AutoHotkeys = maManual;
       Dummy->Caption = (Bookmarks->Items[GetPage()]->Items[i]->Caption);
       QuickBM->Add(Dummy);
   }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Clear all bookmarks.
############################################################################
*/

void __fastcall TForm1::ClearAllBookmarksExecute(TObject *Sender)
{
if (MessageDlg("Are you sure you want to clear all Bookmarks?", mtConfirmation, mbOKCancel, 0) == 1) {
   for (int i=0;i<11;i++) {
       Bookmarks->Items[i]->Clear();
   }
}
};
//---------------------------------------------------------------------------
/*
############################################################################
Add a new bookmark based on the current selection.
############################################################################
*/

void __fastcall TForm1::BookmarkEntryExecute(TObject *Sender)
{
TMenuItem *Dummy = new TMenuItem(Form1);
int Value = GetDATList(GetPage())->Selected->ImageIndex;
Dummy->Caption = "["+String(Value)+"] "+GetDATList(GetPage())->Selected->Text;
Dummy->OnClick = BookmarkClickExecute;
Bookmarks->Items[GetPage()]->Insert(Bookmarks->Items[GetPage()]->Count,Dummy);
};
//---------------------------------------------------------------------------
/*
############################################################################
Load up the appropriate entry after a bookmarks was clicked.
############################################################################
*/

void __fastcall TForm1::BookmarkClickExecute(TObject *Sender)
{
int DatTypeID = ((TMenuItem*)(Sender))->Parent->MenuIndex;
int OpenBracketPos = ((TMenuItem*)(Sender))->Caption.Pos("[");
int CloseBracketPos = ((TMenuItem*)(Sender))->Caption.Pos("]");
int Value = ((TMenuItem*)(Sender))->Caption.SubString(2,CloseBracketPos-OpenBracketPos-1).ToInt();

Form1->Editors->ActivePageIndex = DatTypeID;
if (GetSortingStyle(DatTypeID) == 3) {
    GetDATList(DatTypeID)->Selected = GetDATList(DatTypeID)->Items->Item[Value];
}
else if (GetSortingStyle(DatTypeID) != 3) {
    GetDATList(DatTypeID)->Selected = GetDATList(DatTypeID)->Items->Item[LookEntry(Value,DatTypeID)];
}
ChangeTab->Execute();
};
//---------------------------------------------------------------------------
/*
############################################################################
Load up the appropriate entry after a quick bookmarks was clicked.
############################################################################
*/
void __fastcall TForm1::QuickBMClickExecute(TObject *Sender)
{
   int OpenBracketPos = ((TMenuItem*)(Sender))->Caption.Pos("[");
   int CloseBracketPos = ((TMenuItem*)(Sender))->Caption.Pos("]");
   int Value = ((TMenuItem*)(Sender))->Caption.SubString(2,CloseBracketPos-OpenBracketPos-1).ToInt();

   if (GetSortingStyle(GetPage()) == 3) {
      GetDATList(GetPage())->Selected = GetDATList(GetPage())->Items->Item[Value];
   }
   else if (GetSortingStyle(GetPage()) != 3) {
      GetDATList(GetPage())->Selected = GetDATList(GetPage())->Items->Item[LookEntry(Value,GetPage())];
   }
   ChangeTab->Execute();
};
//---------------------------------------------------------------------------
/*
############################################################################
Clear bookmarks for the current editor only.
############################################################################
*/
void __fastcall TForm1::ClearBookmarksExecute(TObject *Sender)
{
Bookmarks->Items[GetPage()]->Clear();
};
//---------------------------------------------------------------------------

void __fastcall TForm1::ReloadEntryExecute(TObject *Sender)
{
int EntryID = GetDATList(GetPage())->Selected->ImageIndex;
GetDATObject(GetPage())->ReloadEntryFromDefault(EntryID);
ChangeTab->Execute();
};
//---------------------------------------------------------------------------

void __fastcall TForm1::ImgReferenceExecute(TObject *Sender)
{
int TargetID,Modulo;
Form1->UsedList->Items->Clear();

if (Sender == Form1->ImgGRPRef) {
   TargetID = Form1->ImgGRP->Text.ToInt();
   Modulo = 0;
}
else if (Sender == Form1->ImgIscriptRef) {
   TargetID = Form1->ImgIscriptID->Text.ToInt();
   Modulo = 7;
}
for (int i=0;i<GetDATObject(4)->GetDatacount();i++) {
    if (GetDATObject(4)->GetData()[i*GetDATObject(4)->GetOffcount()+Modulo] == TargetID) {
       Form1->UsedList->Items->Add("[I"+String(i)+"] "+String(GetDATList(4)->Items->Item[i]->Text));
    }
}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
if (FileExists(ParamStr(1)) == true) {
   String LoadFileName = ParamStr(1);
   if (ExtractFileExt(LoadFileName).LowerCase() == ".dat") {
      AddHistoryItem(LoadFileName);
      SetLastFolder(ExtractFileDir(LoadFileName));
      CheckDATFile(LoadFileName);
   }
   else if (ExtractFileExt(LoadFileName).LowerCase() == ".mpq") {
      AddHistoryItem(LoadFileName);
      SetLastFolder(ExtractFileDir(LoadFileName));
      CheckMPQFile(LoadFileName);
   }
   else {
      MessageDlg(String("\""+LoadFileName+"\" is not a file that DatEdit can recognize."), mtError, TMsgDlgButtons() << mbOK, 0);
   }
}
DragAcceptFiles(Handle, true);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WmDropFiles(TWMDropFiles& Message)
{
char DropFiles[MAX_PATH];
HDROP hDrop = (HDROP)Message.Drop;
int numFiles = DragQueryFile(hDrop, -1, NULL, NULL);
for (int i=0;i < numFiles;i++) {
    DragQueryFile(hDrop, i, DropFiles, sizeof(DropFiles));
    if (FileExists(DropFiles)) {
       if (ExtractFileExt(DropFiles).LowerCase() == ".dat") {
          AddHistoryItem(DropFiles);
          SetLastFolder(ExtractFileDir(DropFiles));
          CheckDATFile(DropFiles);
       }
       else if (ExtractFileExt(DropFiles).LowerCase() == ".mpq") {
          AddHistoryItem(DropFiles);
          SetLastFolder(ExtractFileDir(DropFiles));
          CheckMPQFile(DropFiles);
       }
       else {
          MessageDlg(String("\""+String(DropFiles)+"\" is not a file that DatEdit can recognize."), mtError, TMsgDlgButtons() << mbOK, 0);
       }
    }
}
DragFinish(hDrop);
};
//---------------------------------------------------------------------------
