//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <io.h>
#include <fcntl.h>
#include <stdio.h>
#include <shellapi.h>
#include <ActnList.hpp>
#include <StdActns.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <StrUtils.hpp>
#include <ExtCtrls.hpp>
#include <AppEvnts.hpp>
#include <FileCtrl.hpp>
#include <IniFiles.hpp>
#include <Buttons.hpp>
#include <Registry.hpp>
//---------------------------------------------------------------------------

class FileData {
      int datacount,offcount,filesize;
      int *Data,*Off,*OffSize,*TempEntry,*TempTab,*TempMix;
      String DatName;
      bool IsLoaded,IsDefault,IsMPQImport,FormatLoaded;
public:
      String GetDatName();
      void SetDatName(String FileName);

      bool GetIsMPQImport();
      void SetIsMPQImport(bool Value);

      bool GetFormatLoaded();
      void SetFormatLoaded(bool Value);

      int GetDatacount();
      int GetOffcount();
      int GetFilesize();
      int* GetData();
      bool GetLoadState();
      bool GetDefaultState();
      void CopyTempEntry(int EntryID);
      void PasteTempEntry(int EntryID);
      void CopyTab(int EntryID,int Tab);
      void PasteTab(int EntryID, int Tab);
      void PasteMix(int EntryID);
      void LoadFormat(String Format);
      void ReloadEntryFromDefault(int EntryID);

      void LoadData (void* InputBuffer);

      void SaveData (String FileName);
      friend void DisplayUnitData (int EntryID);
      friend void DisplayWeaponData (int EntryID);
      friend void DisplayFlingyData (int EntryID);
      friend void DisplaySpriteData (int EntryID);
      friend void DisplayImageData (int EntryID);
      friend void DisplayUpgradeData (int EntryID);
      friend void DisplayTechData (int EntryID);
      friend void DisplaySoundData (int EntryID);
      friend void DisplayPortData (int EntryID);
      friend void DisplayMapData (int EntryID);
      friend void DisplayOrderData (int EntryID);
      friend void ChangeUnitData (unsigned int value,int EntryID,TObject* Target);
      friend void ChangeWeaponData (int value,int EntryID,TObject* Target);
      friend void ChangeFlingyData (int value,int EntryID,TObject* Target);
      friend void ChangeSpriteData (int value,int EntryID,TObject* Target);
      friend void ChangeImageData (int value,int EntryID,TObject* Target);
      friend void ChangeUpgradeData (int value,int EntryID,TObject* Target);
      friend void ChangeTechData (int value,int EntryID,TObject* Target);
      friend void ChangeSoundData (int value,int EntryID,TObject* Target);
      friend void ChangePortData (int value,int EntryID,TObject* Target);
      friend void ChangeMapData (int value,int EntryID,TObject* Target);
      friend void ChangeOrderData (int value,int EntryID,TObject* Target);
};

class ChangeData;
//---------------------------------------------------------------------------

class TForm1 : public TForm
{
__published:
        TActionList *Actions;
        TFileExit *Exit;
        TAction *Open;
        TPageControl *Editors;
        TTabSheet *TechEdit;
        TGroupBox *TechCost;
        TLabel *LabelTechMinerals;
        TLabel *LabelTechVespene;
        TLabel *LabelTechTime;
        TLabel *LabelTechMana;
        TEdit *TechMinerals;
        TEdit *TechVespene;
        TEdit *TechTime;
        TEdit *TechMana;
        TGroupBox *TechProperties;
        TLabel *LabelRace;
        TLabel *LabelTechUnk;
        TEdit *TechUnk;
        TComboBox *TechRace;
        TCheckBox *TechUnused;
        TCheckBox *TechBW;
        TGroupBox *TechDisplay;
        TLabel *LabelTechIcon;
	TLabel *LabelTechLabel;
        TComboBox *TechIconList;
        TComboBox *TechLabelList;
        TTabSheet *FlingyEdit;
        TLabel *LabelSprite;
        TLabel *LabelSpeed;
        TLabel *LabelAcceleration;
        TLabel *LabelHaltDist;
        TLabel *LabelTurnRadius;
        TLabel *LabelMoveControl;
        TEdit *FlingySprite;
        TEdit *FlingySpeed;
        TTabSheet *SpriteEdit;
        TTabSheet *ImageEdit;
        TTabSheet *SoundEdit;
        TTabSheet *PortEdit;
        TTabSheet *MapEdit;
        TTabSheet *UpgradeEdit;
        TTabSheet *OrderEdit;
        TTabSheet *WeapEdit;
        TTabSheet *UnitEdit;
        TEdit *SpriteFile;
	TLabel *LabelSpriteFile;
        TEdit *SpriteHPBar;
        TEdit *SpriteCircleOff;
        TLabel *LabelHPBar;
        TLabel *LabelSelCircle;
        TLabel *LabelCircleVertOff;
        TGroupBox *SpriteSelCircleProps;
        TComboBox *SpriteCircleSize;
        TGroupBox *SpriteProperties;
        TCheckBox *SpriteUnk1;
        TCheckBox *SpriteVisible;
        TGroupBox *FlingyGenProp;
        TGroupBox *UpgBaseCost;
        TEdit *UpgMinerals;
        TEdit *UpgVespene;
        TEdit *UpgTime;
        TLabel *LabelUpgMinerals;
        TLabel *LabelUpgVespene;
        TLabel *LabelUpgTime;
        TGroupBox *UpgFactCost;
        TLabel *LabelUpgFactorMinerals;
        TLabel *LabelUpgFactorVespene;
        TLabel *LabelUpgFactorTime;
        TEdit *UpgFactorMinerals;
        TEdit *UpgFactorVespene;
	TEdit *UpgFactorTime;
        TGroupBox *UpgDisplay;
        TLabel *LabelUpgIcon;
        TLabel *LabelUpgLabel;
        TComboBox *UpgIconList;
        TComboBox *UpgLabelList;
        TGroupBox *UpgProp;
        TLabel *LabelUpgRace;
        TEdit *UpgRepeats;
        TEdit *UpgUnk;
        TLabel *LabelUpgRepeats;
        TCheckBox *UpgIsBW;
        TLabel *LabelUpgUnk;
        TGroupBox *ImgGenProp;
        TCheckBox *ImgGfxTurns;
        TCheckBox *ImgClickable;
        TCheckBox *ImgDrawCloaked;
        TCheckBox *ImgUseIscript;
        TComboBox *ImgPalette;
        TGroupBox *ImgAnim;
        TGroupBox *ImgPaletteProp;
        TLabel *LabelImgPalette;
        TLabel *LabelImgPalType;
        TEdit *ImgOL1;
        TEdit *ImgOL2;
        TEdit *ImgOL3;
        TEdit *ImgOL4;
        TLabel *LabelImgOL1;
        TLabel *LabelImgOL2;
        TLabel *LabelImgOL3;
        TLabel *LabelImgOL4;
        TLabel *LabelImgOL5;
        TComboBox *ImgShieldOL;
        TLabel *LabelShieldOL;
        TEdit *SoundUnk1;
        TEdit *SoundUnk2;
        TEdit *SoundUnk3;
        TLabel *LabelSoundUnk1;
        TLabel *LabelSoundUnk2;
        TLabel *LabelSoundUnk3;
        TLabel *LabelSoundUnk4;
        TGroupBox *SoundGenProp;
        TEdit *SoundUnk4;
        TGroupBox *PortGenProp;
        TEdit *PortFile;
        TEdit *PortSMKChange;
        TLabel *LabelPortFile;
        TLabel *LabelPortUnk1;
        TLabel *LabelPortSMK;
        TLabel *LabelMapFile;
        TGroupBox *MapData;
        TTreeView *UnitList;
        TAction *ChangeTab;
        TComboBox *UpgRace;
        TComboBox *ImgPalSpec;
        TAction *Save;
        TGroupBox *WeapDamage;
        TGroupBox *WeapRange;
        TEdit *WeapRangeMin;
        TEdit *WeapAmount;
        TEdit *WeapBonus;
        TEdit *WeapFactor;
        TEdit *WeapCooldown;
        TLabel *LabelWeapAmount;
        TLabel *LabelWeapBonus;
        TLabel *LabelWeapFactor;
        TLabel *LabelWeapCooldown;
        TLabel *LabelRangeMin;
	TLabel *LabelRangeMax;
        TEdit *WeapRangeMax;
        TGroupBox *WeapSplashRads;
        TEdit *WeapInner;
        TEdit *WeapMed;
        TEdit *WeapOuter;
        TLabel *LabelRadInner;
        TLabel *LabelRadMed;
        TLabel *LabelRadOuter;
        TComboBox *WeapUpgrade;
        TLabel *LabelWeapUpgrade;
        TComboBox *WeapType;
        TComboBox *WeapExplosion;
        TLabel *LabelWeapType;
        TLabel *LabelWeapSpell;
        TLabel *LabelWeapExplosion;
        TGroupBox *WeapGraphical;
        TComboBox *WeapGraphicsList;
        TLabel *LabelWeapGraphics;
        TEdit *WeapAttackAngle;
        TEdit *WeapLaunchSpin;
        TLabel *LabelWeapAttackAngle;
        TLabel *LabelWeapForwardOffset;
        TLabel *LabelWeapUpwardOffset;
        TLabel *LabelWeapLaunchSpin;
	TComboBox *WeapMissile;
        TLabel *LabelMissile;
        TLabel *LabelBehaviour;
        TComboBox *WeapBehaviour;
        TEdit *MapFile;
        TLabel *LabelMapDir;
        TPageControl *UnitTabs;
        TTabSheet *UnitBasic;
        TTabSheet *UnitSound;
        TTabSheet *UnitAdv;
	TTabSheet *UnitGraphics;
        TTabSheet *UnitSE;
        TTabSheet *UnitAI;
        TButton *JumpToSpriteButton;
        TButton *JumpToImageButton;
        TGroupBox *UnitWeapons;
        TComboBox *UnitWeaponGroundList;
        TComboBox *UnitWeaponAirList;
        TLabel *LabelUnitWeaponGround;
        TLabel *LabelUnitGroundMax;
        TLabel *LabelUnitAirMax;
        TLabel *LabelUniWeapontAir;
        TButton *JumpToGround;
        TButton *JumpToAir;
        TGroupBox *UnitAdd;
        TEdit *UnitSupReq;
        TLabel *LabelUnitSupReq;
        TLabel *LabelSpaceReq;
        TLabel *LabelUnitScoreBuild;
        TLabel *LabelUnitSupProv;
        TLabel *LabelUnitSpaceProv;
        TLabel *LabelUnitScoreDestroy;
        TGroupBox *WeapTarget;
        TAction *ChangeEdit;
        TAction *ExitEdit;
        TAction *ChangeCombo;
        TAction *ChangeCheckBox;
        TPanel *ElGrandoListos;
	TCheckBox *WeapTarget001;
	TCheckBox *WeapTarget002;
	TCheckBox *WeapTarget004;
	TCheckBox *WeapTarget008;
	TCheckBox *WeapTarget010;
	TCheckBox *WeapTarget020;
	TCheckBox *WeapTarget040;
	TCheckBox *WeapTarget080;
        TCheckBox *WeapTarget100;
        TAction *JumpToDAT;
	TGroupBox *OrdFlags;
        TCheckBox *OrdWeapTarg;
	TCheckBox *OrdUnk2;
	TCheckBox *OrdUnk5;
        TCheckBox *OrdInterupt;
	TCheckBox *OrdUnk9;
	TCheckBox *OrdUnk10;
	TCheckBox *OrdUnk11;
	TCheckBox *OrdUnk12;
	TCheckBox *OrdUnk7;
        TCheckBox *OrdQueue;
	TCheckBox *OrdUnk3;
	TCheckBox *OrdUnk4;
	TGroupBox *UnitAdvProp;
        TCheckBox *UnitAdvBuilding;
	TCheckBox *UnitAdvAddon;
        TCheckBox *UnitAdvFlyer;
	TCheckBox *UnitAdvWorker;
	TCheckBox *UnitAdvReg;
	TCheckBox *UnitAdvHero;
	TCheckBox *UnitAdvFlyBuilding;
	TCheckBox *UnitAdvSub;
	TCheckBox *UnitAdvDetect;
	TCheckBox *UnitAdvRobo;
        TCheckBox *UnitAdvResContainer;
        TCheckBox *UnitAdvResDepot;
        TCheckBox *UnitAdvSingle;
	TCheckBox *UnitAdvTwoInEgg;
	TCheckBox *UnitAdvCloak;
	TCheckBox *UnitAdvAnimIdle;
	TCheckBox *UnitAdvPsi;
	TCheckBox *UnitAdvUnused;
	TCheckBox *UnitAdvCreep;
	TCheckBox *UnitAdvOrg;
	TCheckBox *UnitAdvPickup;
	TCheckBox *UnitAdvPermaCloak;
	TCheckBox *UnitAdvSpellcaster;
	TCheckBox *UnitAdvBurrow;
        TCheckBox *UnitAdvIgnoreSupply;
	TCheckBox *UnitAdvOverlayMed;
	TCheckBox *UnitAdvOverlayLarge;
	TCheckBox *UnitAdvAttackSight;
	TCheckBox *UnitAdvAttackRange;
	TCheckBox *UnitAdvInv;
	TCheckBox *UnitAdvMech;
	TCheckBox *UnitAdvProd;
	TGroupBox *UnitSounds;
	TGroupBox *UnitAIActions;
	TComboBox *UnitAICompIdle;
	TComboBox *UnitAIHumanIdle;
	TComboBox *UnitAIRightClick;
	TLabel *LabelUnitAICompIdle;
	TLabel *LabelUnitAIHumanIdle;
	TLabel *LabelUnitAIAttackUnit;
	TLabel *LabelUnitAIAttackMove;
	TLabel *LabelUnitAIReturn;
	TLabel *LabelUnitAIRightClick;
	TGroupBox *UnitSEFlags;
	TGroupBox *UnitSEGroupFlags;
	TGroupBox *UnitSpriteProp;
	TComboBox *UnitGfx;
	TLabel *LabelUnitGfx;
	TLabel *LabelUnitConst;
	TLabel *LabelUnitInfest;
	TComboBox *UnitConst;
	TComboBox *UnitInfest;
	TGroupBox *UnitSEStringProp;
        TCheckBox *UnitSENonNeutral;
        TCheckBox *UnitSEUnitHero;
        TCheckBox *UnitSEListing;
	TCheckBox *UnitSEBriefing;
        TCheckBox *UnitSEPlayerSet;
	TCheckBox *UnitSEAllRaces;
        TCheckBox *UnitSEDoodadState;
        TCheckBox *UnitSENonLoc;
	TCheckBox *UnitSEGroupMen;
	TCheckBox *UnitSEGroupNeutral;
	TCheckBox *UnitSEGroupInd;
	TCheckBox *UnitSEGroupFactory;
	TCheckBox *UnitSEGroupBuilding;
	TCheckBox *UnitSEBW;
        TCheckBox *UnitSELoc;
	TLabel *LabelUnitSublabel;
	TLabel *LabelUnitMapString;
	TEdit *UnitSndReady;
	TLabel *LabelUnitSndReady;
        TEdit *UnitSndYesStart;
	TLabel *LabelUnitSndYesStart;
	TLabel *LabelUnitSndYesEnd;
	TLabel *LabelUnitSndWhatStart;
	TLabel *LabelUnitSndWhatEnd;
        TEdit *UnitSndYesEnd;
	TLabel *LabelUnitSndAnnStart;
	TLabel *LabelUnitSndAnnEnd;
	TComboBox *UnitPort;
	TLabel *LabelUnitPort;
	TLabel *LabelUnitAnimLevel;
	TComboBox *UnitAnimLevel;
	TLabel *LabelUnitSize;
	TLabel *LabelUnitSight;
	TComboBox *UnitAIReturn;
	TComboBox *UnitAIAttackUnit;
	TComboBox *UnitAIAttackMove;
	TEdit *UnitSndWhatStart;
	TGroupBox *UnitSEPlaceBox;
	TEdit *UnitSEPlaceHeight;
	TLabel *LabelUnitSEPlaceHeight;
	TEdit *UnitSEPlaceWidth;
	TLabel *LabelUnitSEPlaceWidth;
        TGroupBox *UnitAddonPos;
        TLabel *LabelUnitAddPosX;
        TLabel *LabelUnitAddPosY;
        TEdit *UnitAddPosX;
        TEdit *UnitAddPosY;
        TEdit *UnitDirection;
        TLabel *LabelUnitDirection;
        TEdit *UnitAIInternal;
        TLabel *LabelUnitAIInternal;
        TOpenDialog *OpenDialog;
        TSaveDialog *SaveDialog;
        TAction *SaveAs;
        TPanel *EditorsPanel;
        TGroupBox *InfoBox;
        TMemo *InfoText;
        TMemo *TBLBuf;
        TMemo *TextBuf;
        TStatusBar *StatusBar;
        TLabel *LabelUsed;
        TGroupBox *WeapDisplay;
        TLabel *LabelWeapLabel;
        TLabel *LabelWeapError;
        TComboBox *WeapLabel;
        TComboBox *WeapError;
        TAction *OpenDir;
        TSaveDialog *MPQSave;
        TAction *MPQExport;
        TAction *MPQMultiExport;
        TAction *MPQMultiExportSave;
        TAction *Copy;
        TAction *Paste;
        TEdit *UnitSupProv;
        TEdit *UnitScoreBuild;
        TComboBox *UnitSize;
        TEdit *UnitSpaceReq;
        TEdit *UnitSpaceProv;
        TEdit *UnitSight;
        TGroupBox *SoundGeneral;
        TLabel *LabelSoundFile;
        TEdit *SoundFile;
        TLabel *LabelSoundDir;
        TAction *CopyTab;
        TAction *PasteTab;
        TEdit *UnitRank;
        TLabel *LabelUnitSublabel2;
        TPanel *JumpToIDPanel;
        TLabel *LabelJumpToID;
        TEdit *JumpToID;
        TListBox *UsedList;
        TButton *JumpToWeapUpgrade;
        TButton *JumpToWeapGfx;
        TGroupBox *UnitVitals;
        TLabel *LabelUnitArmUpgrade;
        TLabel *LabelUnitHP;
        TLabel *LabelUnitSP;
        TLabel *LabelUnitArm;
        TEdit *UnitHP;
        TEdit *UnitSP;
        TEdit *UnitArm;
        TComboBox *UnitArmUpgrade;
        TCheckBox *UnitShieldEnable;
        TButton *JumpToUnitPort;
        TButton *JumpToUnitInfest;
        TButton *JumpToUnitConstruction;
        TButton *JumpToUnitGfx;
        TPanel *TechIconPrevBox;
        TPanel *TechIconPrevBG;
        TPanel *UpgIconPrevBox;
        TLabel *LabelWeapIcon;
        TPanel *WeapIconPrevBox;
        TPanel *WeapIconPrevBG;
        TComboBox *WeapIconList;
        TGroupBox *UnitCost;
        TCheckBox *UnitIsBW;
        TLabel *LabelUnitTime;
        TLabel *LabelUnitVespene;
        TLabel *LabelUnitMinerals;
        TEdit *UnitMinerals;
        TEdit *UnitVespene;
        TEdit *UnitTime;
        TTreeView *WeaponList;
        TTreeView *UpgradeList;
        TTreeView *OrdList;
        TTreeView *SoundList;
        TTreeView *MapList;
        TTreeView *TechList;
        TTreeView *PortList;
        TTreeView *SpritesList;
        TTreeView *ImageList;
        TAction *PasteMixed;
        TAction *LoadHistoryItem;
        TPanel *UpgIconPrevBG;
        TImage *TechIconPrev;
        TImage *UpgIconPrev;
        TImage *WeapIconPrev;
        TAction *ReadConfig;
        TAction *SaveConfig;
        TAction *ClearHistory;
        TAction *ReadConfigOptions;
        TAction *SaveConfigOptions;
        TLabel *LabelPortDir;
        TGroupBox *PortGenProps;
        TAction *SetSorting;
        TTreeView *FlingyList;
        TGroupBox *ImgFile;
        TLabel *LabelImageDir;
        TEdit *ImgGRP;
        TLabel *ImgLabelGRP;
        TMemo *TextBuf2;
        TLabel *LabelImgIscriptID;
        TEdit *ImgIscriptID;
        TLabel *LabelImgIscriptDir;
        TComboBox *SpriteImageList;
        TLabel *LabelSpriteDir;
        TComboBox *FlingySpriteList;
        TLabel *LabelFlingyDir;
        TEdit *UnitMapString;
        TAction *LoadHint;
        TButton *SearchButton;
        TPanel *ZSearch;
        TAction *SearchList;
        TGroupBox *UnitSpace;
        TGroupBox *UnitSupply;
        TGroupBox *UnitScore;
        TEdit *UnitScoreDestroy;
        TLabel *LabelID;
        TEdit *ID;
        TEdit *ImgOL5;
        TEdit *ImgShield;
        TLabel *LabelCircleDir;
        TEdit *SpriteSelCircle;
        TAction *ReloadDefault;
        TEdit *PortUnk1;
        TButton *CheckSndReady;
        TButton *CheckSndYesS;
        TButton *CheckSndYesE;
        TButton *CheckSndWhtS;
        TButton *CheckSndWhtE;
        TButton *CheckSndAnnS;
        TButton *CheckSndAnnE;
        TEdit *WeapForwardOffset;
        TEdit *WeapUpwardOffset;
        TButton *JumpToCompIdle;
        TButton *JumpToHumanIdle;
        TButton *JumpToReturnToIdle;
        TButton *JumpToAttackUnit;
        TButton *JumpToAttackMove;
        TCheckBox *UnitSEGroupProtoss;
        TCheckBox *UnitSEGroupTerran;
        TCheckBox *UnitSEGroupZerg;
        TCheckBox *UnitSupReq05;
        TCheckBox *UnitSupProv05;
        TLabel *LabelUnitSubRange;
        TEdit *UnitSubRange;
        TComboBox *SearchText;
        TEdit *FlingyAcceleration;
        TEdit *FlingyHaltDist;
        TEdit *FlingyTurnRad;
        TComboBox *FlingyMoveControl;
        TComboBox *ImgGRPTBL;
        TComboBox *ImgIscriptIDList;
        TComboBox *ImgOL1TBL;
        TLabel *LabelEqFlingy1;
        TComboBox *ImgOL2TBL;
        TLabel *LabelEqFlingy2;
        TComboBox *ImgOL3TBL;
        TLabel *LabelEqFlingy3;
        TComboBox *ImgOL4TBL;
        TLabel *LabelEqFlingy4;
        TComboBox *ImgOL5TBL;
        TLabel *LabelEqFlingy5;
        TComboBox *ImgShieldTBL;
        TLabel *LabelEqFlingy6;
        TGroupBox *UnitSubunits;
        TLabel *LabelUnitSub1;
        TLabel *LabelUnitSub2;
        TComboBox *UnitSub1;
        TComboBox *UnitSub2;
        TGroupBox *UnitDims;
        TLabel *LabelUnitDimLeft;
        TLabel *LabelUnitDimRight;
        TLabel *LabelUnitDimUp;
        TLabel *LabelUnitDimDown;
        TEdit *UnitDimLeft;
        TEdit *UnitDimRight;
        TEdit *UnitDimUp;
        TEdit *UnitDimDown;
        TGroupBox *UnitVariousProperties;
        TCheckBox *UnitMov01;
        TCheckBox *UnitMov02;
        TCheckBox *UnitMov08;
        TCheckBox *UnitMov04;
        TCheckBox *UnitMov20;
        TCheckBox *UnitMov10;
        TCheckBox *UnitMov80;
        TCheckBox *UnitMov40;
        TGroupBox *UnitDimView;
        TShape *SizeRect;
        TShape *SizeRefPoint;
        TComboBox *MapTBL;
        TComboBox *PortTBL;
        TComboBox *SoundTBL;
        TComboBox *UnitSndReadyList;
        TComboBox *UnitSndYesStartList;
        TComboBox *UnitSndYesEndList;
        TComboBox *UnitSndWhatStartList;
        TComboBox *UnitSndWhatEndList;
        TComboBox *UnitSndAnnStartList;
        TLabel *LabelEqUnits6;
        TLabel *LabelEqUnits5;
        TLabel *LabelEqUnits4;
        TLabel *LabelEqUnits3;
        TLabel *LabelEqUnits2;
        TLabel *LabelEqUnits1;
        TEdit *UnitSndWhatEnd;
        TEdit *UnitSndAnnStart;
        TEdit *UnitSndAnnEnd;
        TComboBox *UnitSndAnnEndList;
        TLabel *LabelEqUnits7;
	TAction *MPQReturnExport;
        TAction *ClearAllBookmarks;
        TAction *BookmarkClick;
        TAction *BookmarkEntry;
        TPopupMenu *PopupMenu;
        TMenuItem *QuickBM;
        TMenuItem *N8;
        TMenuItem *CopyEntry1;
        TMenuItem *PasteEntry1;
        TMenuItem *Bookmarkentry1;
        TAction *QuickBMClick;
        TAction *ClearBookmarks;
        TComboBox *WeapUnused;
        TMenuItem *N13;
        TMenuItem *Reloadentry1;
        TAction *ReloadEntry;
        TMainMenu *MainMenu;
        TMenuItem *FileMenu;
        TMenuItem *OpenFile;
        TMenuItem *OpenDirectory;
        TMenuItem *MRUD;
        TMenuItem *N10;
        TMenuItem *Options;
        TMenuItem *LoadDefault;
        TMenuItem *N1;
        TMenuItem *FileSave;
        TMenuItem *FileSaveAs;
        TMenuItem *SingleFileMPQExport1;
        TMenuItem *ExportMultipleToMPQ;
        TMenuItem *N2;
        TMenuItem *SaveArchiveAs1;
        TMenuItem *N4;
        TMenuItem *Exit1;
        TMenuItem *EditMenu;
        TMenuItem *Copy1;
        TMenuItem *Paste1;
        TMenuItem *N5;
        TMenuItem *CopyTab1;
        TMenuItem *PasteTab1;
        TMenuItem *N6;
        TMenuItem *PasteMixed1;
        TMenuItem *ViewMenu;
        TMenuItem *SortbyData;
        TMenuItem *SortbyOrigin;
        TMenuItem *N7;
        TMenuItem *SortbyID;
        TMenuItem *Bookmarks;
        TMenuItem *UnitsBM;
        TMenuItem *WeaponsBM;
        TMenuItem *FlingyBM;
        TMenuItem *SpritesBM;
        TMenuItem *ImagesBM;
        TMenuItem *UpgradesBM;
        TMenuItem *TechBM;
        TMenuItem *SoundsBM;
        TMenuItem *PortraitsBM;
        TMenuItem *CampaignBM;
        TMenuItem *OrdersBM;
        TMenuItem *N9;
        TMenuItem *ClearCurrentBookmarks1;
        TMenuItem *N12;
        TMenuItem *ClearBookmarks1;
        TMenuItem *HelpMenu;
        TMenuItem *DoodadsInfo1;
        TMenuItem *N3;
        TMenuItem *Credits;
        TMenuItem *AboutDatEdit;
        TMenuItem *N14;
        TLabel *LabelUnitRestricts;
        TEdit *UnitUnk1;
        TEdit *FlingyUnk;
        TLabel *LabelFlingyUnk;
        TEdit *UnitWeaponGround;
        TEdit *UnitWeaponAir;
        TEdit *UnitGroundMax;
        TEdit *UnitAirMax;
        TLabel *LabelEqUnits8;
        TLabel *LabelEqUnits9;
        TEdit *WeapGraphics;
        TLabel *LabelEqWeapons1;
        TLabel *LabelEqWeapons2;
        TEdit *WeapIcon;
        TEdit *UpgIcon;
        TLabel *LabelEqUpg1;
        TEdit *UpgLabel;
        TLabel *LabelEqUpg2;
        TLabel *LabelTechEq1;
        TLabel *LabelTechEq2;
        TEdit *TechLabel;
        TEdit *TechIcon;
        TComboBox *UnitSublabel;
        TMemo *UnitSubMemo;
        TButton *ImgGRPRef;
        TButton *ImgIscriptRef;
        TAction *ImgReference;
        TGroupBox *OrdProp;
        TLabel *LabelOrdLabel;
        TLabel *LabelOrdEmulate;
        TLabel *LabelOrdAnimation;
        TComboBox *OrdLabel;
        TComboBox *OrdEmulate;
        TComboBox *OrdAnimation;
        TLabel *LabelOrdWeapon;
        TComboBox *OrdWeapon;
        TLabel *LabelOrdTech;
        TComboBox *OrdTech;
        TButton *JumpToOrdTech;
        TButton *JumpToOrdWeapon;
        TLabel *LabelOrdHighlight;
        TEdit *OrdHighlight;
        TLabel *OrdEq1;
        TComboBox *OrdHighlightList;
        TPanel *OrdHighlistPrevBox;
        TPanel *OrdHighlightBG;
        TImage *OrdHighlightPrev;
        TLabel *LabelOrdUnk;
        TEdit *OrdUnk;
        TCheckBox *UnitSE0x400;
        TCheckBox *UnitSE0x800;
        TCheckBox *UnitSE0x1000;
        TCheckBox *UnitSE0x2000;
        TCheckBox *UnitSE0x4000;
        TCheckBox *UnitSE0x8000;

	void __fastcall AboutClick(TObject *Sender);
	void __fastcall OpenExecute(TObject *Sender);
	void __fastcall OpenDialogCanClose(TObject *Sender,
	  bool &CanClose);
	void __fastcall SaveExecute(TObject *Sender);
	void __fastcall JumpToIDKeyDown(TObject *Sender, WORD &Key,
	  TShiftState Shift);
	void __fastcall ChangeTabExecute(TObject *Sender);
	void __fastcall WeapEditShow(TObject *Sender);
	void __fastcall FlingyEditShow(TObject *Sender);
	void __fastcall SpriteEditShow(TObject *Sender);
	void __fastcall ImageEditShow(TObject *Sender);
	void __fastcall UpgradeEditShow(TObject *Sender);
	void __fastcall TechEditShow(TObject *Sender);
	void __fastcall MapEditShow(TObject *Sender);
	void __fastcall OrderEditShow(TObject *Sender);

	void __fastcall ChangeEditExecute(TObject *Sender);
	void __fastcall ExitEditExecute(TObject *Sender);
	void __fastcall ChangeComboExecute(TObject *Sender);
	void __fastcall ChangeCheckBoxExecute(TObject *Sender);
	void __fastcall JumpToDATExecute(TObject *Sender);

	void __fastcall FlagToggler(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y);
        void __fastcall CreditsClick(TObject *Sender);
        void __fastcall SaveAsExecute(TObject *Sender);
        void __fastcall SaveDialogCanClose(TObject *Sender,
          bool &CanClose);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall UsedListDblClick(TObject *Sender);
        void __fastcall OpenDirExecute(TObject *Sender);
        void __fastcall MPQSaveCanClose(TObject *Sender, bool &CanClose);
        void __fastcall MPQExportExecute(TObject *Sender);
        void __fastcall MPQMultiExportExecute(TObject *Sender);
        void __fastcall MPQMultiExportSaveExecute(TObject *Sender);
        void __fastcall EditMenuClick(TObject *Sender);
        void __fastcall CopyExecute(TObject *Sender);
        void __fastcall PasteExecute(TObject *Sender);
        void __fastcall DoodadsInfo1Click(TObject *Sender);
        void __fastcall SoundEditShow(TObject *Sender);
        void __fastcall ListChange(TObject *Sender, TTreeNode *Node);
        void __fastcall CopyTabExecute(TObject *Sender);
        void __fastcall PasteTabExecute(TObject *Sender);
        void __fastcall PasteMixedExecute(TObject *Sender);
        void __fastcall FileMenuClick(TObject *Sender);
        void __fastcall ClearHistoryClick(TObject *Sender);
        void __fastcall LoadHistoryItemExecute(TObject *Sender);
        void __fastcall ShowUnitSizePreviewClick(TObject *Sender);
        void __fastcall UnitTabsChange(TObject *Sender);
        void __fastcall UnitBasicShow(TObject *Sender);
        void __fastcall UnitGraphicsShow(TObject *Sender);
        void __fastcall UnitSEShow(TObject *Sender);
        void __fastcall UnitAIShow(TObject *Sender);
        void __fastcall ReadConfigExecute(TObject *Sender);
        void __fastcall SaveConfigExecute(TObject *Sender);
        void __fastcall OptionsClick(TObject *Sender);
        void __fastcall ClearHistoryExecute(TObject *Sender);
        void __fastcall ReadConfigOptionsExecute(TObject *Sender);
        void __fastcall SaveConfigOptionsExecute(TObject *Sender);
        void __fastcall ViewMenuClick(TObject *Sender);
        void __fastcall SetSortingExecute(TObject *Sender);
        void __fastcall PortEditShow(TObject *Sender);
        void __fastcall LoadHintExecute(TObject *Sender);
        void __fastcall SearchTextKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall SearchListExecute(TObject *Sender);
        void __fastcall ReloadDefaultExecute(TObject *Sender);
        void __fastcall UnitAdvShow(TObject *Sender);
        void __fastcall UnitSoundShow(TObject *Sender);
	void __fastcall MPQReturnExportExecute(TObject *Sender);
        void __fastcall ListMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ClearAllBookmarksExecute(TObject *Sender);
        void __fastcall BookmarkClickExecute(TObject *Sender);
        void __fastcall BookmarkEntryExecute(TObject *Sender);
        void __fastcall PopupMenuPopup(TObject *Sender);
        void __fastcall QuickBMClickExecute(TObject *Sender);
        void __fastcall ClearBookmarksExecute(TObject *Sender);
        void __fastcall ReloadEntryExecute(TObject *Sender);
        void __fastcall ImgReferenceExecute(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);

//---------------------------------------------------------------------------
private:
        int Page, SubPage, StartEditor;
        int *TabSortingStyle;
        bool MultiDATExport,MultiMPQIcons,IconIsMPQImport,UseCustomNames;
        bool *ListReload,*EditorReload;
        TBits *TempDats,*TempTabs,*MultiMPQDats,*MultiMPQTBLs,*TBLIsMPQImport;

        String LastFolder,MPQName,ProgPath,TempPath,MPQPath;
        String Ver,Icons,MPQIcons;

        String *TBLs,*MPQTBLs;
        void __fastcall WmDropFiles(TWMDropFiles& Message);
//---------------------------------------------------------------------------
public:
        __fastcall TForm1(TComponent* Owner);
        void InitializeValues();
        void SetStartEditor(int PageIndex);
        void AddHistoryItem(String ItemName);

        void SetVer(String Version);
        String GetVer ();

        void SetMultiMPQDats(TBits *MPQDats);
        bool GetMultiMPQDats(int Index);

        void SetMultiDATExport(bool Value);
        bool GetMultiDATExport();

        void SetPage(int PageIndex);
        int GetPage();

        void SetSubPage(int SubPageIndex);
        int GetSubPage();

        bool GetTempDats(int PageIndex);
        void SetTempDats(int PageIndex, bool Value);

        bool GetTempTabs(int PageIndex);
        void SetTempTabs(int Index, bool Value);

        int GetSortingStyle(int PageIndex);
        void SetSortingStyle(int PageIndex, int Value);

        bool GetListReload(int PageIndex);
        void SetListReload(int PageIndex, bool Value);

        bool GetEditorReload(int PageIndex);
        void SetEditorReload(int PageIndex, bool Value);

        String GetTBL(int Index);
        void SetTBL(int Index, String Value);

        String GetIcons();
        void SetIcons(String FileName);

        void SetMultiMPQTBLs(TBits *MPQTBLs);
        bool GetMultiMPQTBLs(int Index);

        void SetMultiMPQIcons(bool MPQIconsState);
        bool GetMultiMPQIcons ();

        void SetLastFolder(String Folder);
        String GetLastFolder();

        void SetMPQName(String MPQName);
        String GetMPQName();

        void SetProgPath(String ProgPath);
        String GetProgPath();

        void SetTempPath(String TempPath);
        String GetTempPath();

        void SetMPQPath(String MPQPath);
        String GetMPQPath();

        void SetTBLIsMPQImport(int Index,bool Value);
        bool GetTBLIsMPQImport(int Index);

        void SetIconIsMPQImport(bool Value);
        bool GetIconIsMPQImport();

        String GetMPQTBL(int Index);
        void SetMPQTBL(int Index, String Value);

        String GetMPQIcons();
        void SetMPQIcons(String Value);

        void SetUseCustomNames(bool Value);
        bool GetUseCustomNames();

        BEGIN_MESSAGE_MAP
           MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WmDropFiles)
        END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
