//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Options.h"
#include "Main.h"
#include "Data.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TOptionsBox *OptionsBox;
//---------------------------------------------------------------------------
__fastcall TOptionsBox::TOptionsBox(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TOptionsBox::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
if (Key == VK_ESCAPE) {
   OptionsBox->Close();
}
};
//---------------------------------------------------------------------------
void __fastcall TOptionsBox::ClearBookmarksClick(TObject *Sender)
{
Form1->ClearAllBookmarks->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsBox::ClearHistoryClick(TObject *Sender)
{
Form1->ClearHistory->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsBox::DefaultSizeClick(TObject *Sender)
{
Form1->Width = 762;
Form1->Height = 575;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsBox::OptionsBoxOKClick(TObject *Sender)
{
OptionsBox->Close();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsBox::FormShow(TObject *Sender)
{
Form1->ReadConfigOptions->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsBox::FormCreate(TObject *Sender)
{
Form1->ReadConfigOptions->Execute();
if (ShowSplash->Checked == false) {
   Form1->Show();
}
}
//---------------------------------------------------------------------------
void __fastcall TOptionsBox::FormClose(TObject *Sender, TCloseAction &Action)
{
Form1->SaveConfigOptions->Execute();
Form1->SizeRefPoint->Visible = OptionsBox->ShowUnitSizePreview->Checked;
Form1->SizeRect->Visible = OptionsBox->ShowUnitSizePreview->Checked;
if (Form1->GetEditorReload(Form1->GetPage()) == true) {
    if (Form1->GetPage() == 0) {
       if (Form1->GetSubPage() == 4) {
          Form1->UnitSE->OnShow(Form1);
       }
    }
    else
        Form1->Editors->Pages[Form1->GetPage()]->OnShow(Form1);
} 
}
//---------------------------------------------------------------------------
 
void __fastcall TOptionsBox::CustomTBLLoad(TObject *Sender)
{
int TBLTag;
String TBLName;
if (Sender == StatLoad) {
    TBLTag = 0;
    TBLName = "stat_txt.tbl";
}
else if (Sender == ImagesLoad) {
    TBLTag = 1;
    TBLName = "images.tbl";
}
else if (Sender == PortdataLoad) {
    TBLTag = 2;
    TBLName = "portdata.tbl";
}
else if (Sender == SfxLoad) {
    TBLTag = 3;
    TBLName = "sfxdata.tbl";
}
else if (Sender == MapdataLoad) {
    TBLTag = 4;
    TBLName = "mapdata.tbl";
}
LoadTBL->Filter = String(GetTBLType(TBLTag)+".tbl | "+GetTBLType(TBLTag)+".tbl");
LoadTBL->Tag = TBLTag;
LoadTBL->Title = "Load "+TBLName;
LoadTBL->Execute();
}
//---------------------------------------------------------------------------

void __fastcall TOptionsBox::LoadTBLCanClose(TObject *Sender,
      bool &CanClose)
{
if (ExtractFileExt(LoadTBL->FileName).AnsiCompareIC(".tbl") != 0) {
   MessageDlg("The selected file is not a TBL file. Please choose a TBL file.", mtError, TMsgDlgButtons() <<mbOK, 0);
   CanClose = false;
}
else {

for (int i=0;i<5;i++) {
    if (LoadTBL->Tag == i) {
       if (ExtractFileName(LoadTBL->FileName).AnsiCompareIC(GetTBLType(i)+".tbl") != 0) {
          CanClose = false;
          MessageDlg("File is not \""+GetTBLType(i)+".tbl\".",mtError,TMsgDlgButtons() <<mbOK,0);
       }
       else if (ExtractFileName(LoadTBL->FileName).AnsiCompareIC(GetTBLType(i)+".tbl") == 0) {
            CanClose = true;
            switch (i) {
              case 0:
                  StatPath->Text = LoadTBL->FileName;
                  Form1->SetTBL(LoadTBL->Tag,StatPath->Text);
                  Form1->SetEditorReload(0,true);
                  Form1->SetEditorReload(1,true);
                  Form1->SetEditorReload(5,true);
                  Form1->SetEditorReload(6,true);
                  Form1->SetEditorReload(10,true);
                  break;
              case 1:
                  ImagesPath->Text = LoadTBL->FileName;
                  Form1->SetTBL(LoadTBL->Tag,ImagesPath->Text);
                  Form1->SetEditorReload(4,true);
              case 2:
                  PortdataPath->Text = LoadTBL->FileName;
                  Form1->SetTBL(LoadTBL->Tag,PortdataPath->Text);
                  Form1->SetEditorReload(8,true);
                  break;
              case 3:
                  SfxPath->Text = LoadTBL->FileName;
                  Form1->SetTBL(LoadTBL->Tag,SfxPath->Text);
                  Form1->SetEditorReload(7,true);
                  break;
              case 4:
                  MapdataPath->Text = LoadTBL->FileName;
                  Form1->SetTBL(LoadTBL->Tag,MapdataPath->Text);
                  Form1->SetEditorReload(9,true);
                  break;
            }
       }
    }
}
}
}
//---------------------------------------------------------------------------

void __fastcall TOptionsBox::DefaultTBLClick(TObject *Sender)
{
if (Sender == DefaultStat) {
   StatPath->Text = (Form1->GetProgPath()+"default\\stat_txt.tbl");
   Form1->SetTBL(0,StatPath->Text);
   Form1->SetEditorReload(0,true);
   Form1->SetEditorReload(1,true);
   Form1->SetEditorReload(5,true);
   Form1->SetEditorReload(6,true);
   Form1->SetEditorReload(10,true);
}
else if (Sender == DefaultImages) {
   ImagesPath->Text = (Form1->GetProgPath()+"default\\images.tbl");
   Form1->SetTBL(1,ImagesPath->Text);
   Form1->SetEditorReload(4,true);
}
else if (Sender == DefaultPortdata) {
   PortdataPath->Text = (Form1->GetProgPath()+"default\\portdata.tbl");
   Form1->SetTBL(2,PortdataPath->Text);
   Form1->SetEditorReload(8,true);
}
else if (Sender == DefaultSfx) {
   SfxPath->Text = (Form1->GetProgPath()+"default\\sfxdata.tbl");
   Form1->SetTBL(3,SfxPath->Text);
   Form1->SetEditorReload(7,true);
}
else if (Sender == DefaultMapdata) {
   MapdataPath->Text = (Form1->GetProgPath()+"default\\mapdata.tbl");
   Form1->SetTBL(4,MapdataPath->Text);
   Form1->SetEditorReload(9,true);
}
}
//---------------------------------------------------------------------------

void __fastcall TOptionsBox::TBLPathChange(TObject *Sender)
{
if (((TEdit*)(Sender))->Modified == true) {
if (Sender == StatPath) {
   Form1->SetTBL(0,StatPath->Text);
   Form1->SetEditorReload(0,true);
   Form1->SetEditorReload(1,true);
   Form1->SetEditorReload(5,true);
   Form1->SetEditorReload(6,true);
   Form1->SetEditorReload(10,true);
}
else if (Sender == ImagesPath) {
   Form1->SetTBL(1,ImagesPath->Text);
   Form1->SetEditorReload(4,true);
}
else if (Sender == PortdataPath) {
   Form1->SetTBL(2,PortdataPath->Text);
   Form1->SetEditorReload(8,true);
}
else if (Sender == SfxPath) {
   Form1->SetTBL(3,SfxPath->Text);
   Form1->SetEditorReload(7,true);
}
else if (Sender == MapdataPath) {
   Form1->SetTBL(4,MapdataPath->Text);
   Form1->SetEditorReload(9,true);
}
}
}
//---------------------------------------------------------------------------

void __fastcall TOptionsBox::IconsLoadClick(TObject *Sender)
{
LoadIcons->Execute();
}
//---------------------------------------------------------------------------

void __fastcall TOptionsBox::LoadIconsCanClose(TObject *Sender,
      bool &CanClose)
{
CanClose = false;
if (ExtractFileName(LoadIcons->FileName).AnsiCompareIC("cmdicons.grp") != 0) {
   MessageDlg("File is not \"cmdicons.grp\".\nYou must choose a \"cmdicons.grp\" file.", mtError, TMsgDlgButtons() << mbOK, 0);
   CanClose = false;
}
else if (ExtractFileName(LoadIcons->FileName).AnsiCompareIC("cmdicons.grp") == 0) {
   IconsPath->Text = LoadIcons->FileName;
   Form1->SetIcons(LoadIcons->FileName);
   Form1->SetEditorReload(1,true);
   Form1->SetEditorReload(5,true);
   Form1->SetEditorReload(6,true);
   CanClose = true;
}
}
//---------------------------------------------------------------------------

void __fastcall TOptionsBox::IconsDefClick(TObject *Sender)
{
   IconsPath->Text = (Form1->GetProgPath()+"default\\cmdicons.grp");
   Form1->SetIcons(Form1->GetProgPath()+"default\\cmdicons.grp");
   Form1->SetEditorReload(1,true);
   Form1->SetEditorReload(5,true);
   Form1->SetEditorReload(6,true);
}
//---------------------------------------------------------------------------

void __fastcall TOptionsBox::IconsPathChange(TObject *Sender)
{
if (((TEdit*)(Sender))->Modified == true) {
   Form1->SetIcons(IconsPath->Text);
   Form1->SetEditorReload(1,true);
   Form1->SetEditorReload(5,true);
   Form1->SetEditorReload(6,true);
}
}
//---------------------------------------------------------------------------

void __fastcall TOptionsBox::AssociateDATClick(TObject *Sender)
{
TRegistry *Reg = new TRegistry();
Reg->RootKey = HKEY_CLASSES_ROOT;
Reg->OpenKey(".dat", true);
Reg->WriteString("", "StarCraft.DATfile");
Reg->CloseKey();

Reg->OpenKey("StarCraft.DATfile", true);
Reg->WriteString("", "StarCraft data source file");
Reg->OpenKey("DefaultIcon", true);
Reg->WriteString("", ParamStr(0) + ",0");
Reg->OpenKey("shell", true);
Reg->WriteString("", "open");
Reg->OpenKey("open", true);
Reg->WriteString("", "&Open");
Reg->OpenKey("command", true);
Reg->WriteString("", ParamStr(0) + " \"\%1\"");
Reg->CloseKey();
MessageDlg("DAT files succesfully associated with DatEdit", mtInformation, TMsgDlgButtons() << mbOK, 0);
delete Reg;
}
//---------------------------------------------------------------------------


