//---------------------------------------------------------------------------
#pragma hdrstop

#include "TForm1.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
/*
############################################################################
Initialize certain core variables that are needed later.
############################################################################
*/

void TForm1::InitializeValues() {
     Form1->SetProgPath(ExtractFilePath(Application->ExeName));
     for (int i=0;i<100;i++) {
         if (DirectoryExists(Form1->GetProgPath()+"temp"+String(i+1)+"\\")) {
            continue;
         }
         else {
            if (ForceDirectories(Form1->GetProgPath()+"temp"+String(i+1)+"\\")) {
     	       Form1->SetTempPath(Form1->GetProgPath()+"temp"+String(i+1)+"\\");
            }
            else {
               MessageDlg("Could not create the program temporary directory.\n     DatEdit will now terminate.", mtError, TMsgDlgButtons() << mbOK, 0);
               Application->Terminate();
            }
            if (ForceDirectories(Form1->GetTempPath()+"mpq\\")) {
     	       Form1->SetMPQPath(Form1->GetTempPath()+"mpq\\");
            }
            else {
               MessageDlg("Could not create the program temporary MPQ directory.\n     DatEdit will now terminate.", mtError, TMsgDlgButtons() << mbOK, 0);
               Application->Terminate();
            }
            break;
         }
     }

     TIniFile *ConfigIni = new TIniFile(Form1->GetProgPath()+"DatEdit.ini");

     Form1->TabSortingStyle = new int[11];
     for (int i=0;i<11;i++) {
     	switch (i) {
        case 0:
             TabSortingStyle[0] = ConfigIni->ReadInteger("Sorting","Units Editor",3);
             break;
        case 1:
             TabSortingStyle[1] = ConfigIni->ReadInteger("Sorting","Weapons Editor",3);
             break;
	case 5:
	     TabSortingStyle[5] = ConfigIni->ReadInteger("Sorting","Upgrades Editor",3);
             break;
        case 6:
	     TabSortingStyle[6] = ConfigIni->ReadInteger("Sorting","Techs Editor",3);
             break;
	default:
             TabSortingStyle[i] = 3;
             break;
        }
     }
     TBLs = new String[5];
     MPQTBLs = new String[5];
     ListReload = new bool[11];
     EditorReload = new bool[11];
     for (int i=0;i<11;i++) {
         ListReload[i] = false;
         EditorReload[i] = true;
     }

     TempDats = new TBits;
     TempDats->Size = 11;
     TempTabs = new TBits;
     TempTabs->Size = 6;
     TBLIsMPQImport = new TBits;
     TBLIsMPQImport->Size = 5;

     SetMultiMPQIcons(false);
     SetMultiDATExport(false);
     SetIconIsMPQImport(false);
     for (int i=0;i<5;i++) {
         SetTBLIsMPQImport(i,false);
     }

     SetVer("1.4");
     Form1->Caption = "DatEdit v"+GetVer();
     Application->Title = "DatEdit v"+GetVer();

     delete ConfigIni;
};

//------------------------------------------------------------------------------
/*
############################################################################
Add a new history item. Check if the item is already in the list, and
add it only if it is not yet there.
############################################################################
*/
void TForm1::AddHistoryItem(String ItemName) {
    if (Form1->MRUD->Items[0]->Caption.Pos("<") != 0) {
       Form1->MRUD->Delete(0);
    }
    bool IsHistory=false;
    for (int i=0;i<Form1->MRUD->Count;i++) {
        if (Form1->MRUD->Items[i]->Caption == ItemName) {
           IsHistory = true;
           break;
        }
    }
    if (IsHistory == false) {
        TMenuItem *HistoryItem = new TMenuItem(Form1);
        HistoryItem->Caption = ItemName;
        HistoryItem->OnClick = Form1->LoadHistoryItemExecute;
        Form1->MRUD->Insert(0,HistoryItem);
        if (Form1->MRUD->Count > 10) {
            Form1->MRUD->Items[10]->Free();
        }
    }
};
//------------------------------------------------------------------------------
/*
############################################################################
The following routines control access to TForm1 class member variables.
I use them like global variables, but with an organized access.
The meaning of these variables is obvious, and you can guess it by their
names already. Otherwise, look around where and when they are used.
############################################################################
*/

bool TForm1::GetMultiMPQDats (int Index) {
     return Form1->MultiMPQDats->Bits[Index];
};

void TForm1::SetMultiMPQDats (TBits *MPQDats) {
     Form1->MultiMPQDats = MPQDats;
};
//------------------------------------------------------------------------------

bool TForm1::GetTempDats (int PageIndex) {
     return Form1->TempDats->Bits[PageIndex];
};

void TForm1::SetTempDats (int PageIndex, bool Value) {
     Form1->TempDats->Bits[PageIndex] = Value;
};
//------------------------------------------------------------------------------

bool TForm1::GetTempTabs (int PageIndex) {
     return Form1->TempTabs->Bits[PageIndex];
};

void TForm1::SetTempTabs (int Index, bool Value) {
     Form1->TempTabs->Bits[Index] = Value;
};
//------------------------------------------------------------------------------

String TForm1::GetVer () {
     return Form1->Ver;
};

void TForm1::SetVer (String Version) {
     Form1->Ver = Version;
};
//------------------------------------------------------------------------------

bool TForm1::GetMultiDATExport() {
     return Form1->MultiDATExport;
};

void TForm1::SetMultiDATExport(bool Value) {
     Form1->MultiDATExport = Value;
};
//------------------------------------------------------------------------------

int TForm1::GetPage() {
     return Form1->Page;
};

void TForm1::SetPage(int PageIndex) {
     Form1->Page = PageIndex;
};
//------------------------------------------------------------------------------

int TForm1::GetSubPage() {
     return Form1->SubPage;
}

void TForm1::SetSubPage(int SubPageIndex) {
     Form1->SubPage = SubPageIndex;
}
//------------------------------------------------------------------------------

void TForm1::SetStartEditor(int PageIndex) {
     Form1->StartEditor = PageIndex;
};
//------------------------------------------------------------------------------

int TForm1::GetSortingStyle (int PageIndex) {
     return Form1->TabSortingStyle[PageIndex];
};

void TForm1::SetSortingStyle (int PageIndex, int SortingStyle) {
     Form1->TabSortingStyle[PageIndex] = SortingStyle;
};
//------------------------------------------------------------------------------

bool TForm1::GetListReload (int PageIndex) {
     return Form1->ListReload[PageIndex];
};

void TForm1::SetListReload (int PageIndex, bool Value) {
     Form1->ListReload[PageIndex] = Value;
};
//------------------------------------------------------------------------------

String TForm1::GetTBL (int Index) {
     return Form1->TBLs[Index];
};

void TForm1::SetTBL (int Index, String Value) {
     Form1->TBLs[Index] = Value;
};
//------------------------------------------------------------------------------

bool TForm1::GetEditorReload (int PageIndex) {
     return Form1->EditorReload[PageIndex];
};

void TForm1::SetEditorReload (int PageIndex, bool Value) {
     Form1->EditorReload[PageIndex] = Value;
};
//------------------------------------------------------------------------------

String TForm1::GetIcons () {
     return Form1->Icons;
};

void TForm1::SetIcons (String FileName) {
     Form1->Icons = FileName;
};
//------------------------------------------------------------------------------

bool TForm1::GetMultiMPQTBLs (int Index) {
     return Form1->MultiMPQTBLs->Bits[Index];
};

void TForm1::SetMultiMPQTBLs (TBits *MPQTBLs) {
     Form1->MultiMPQTBLs = MPQTBLs;
};
//------------------------------------------------------------------------------

bool TForm1::GetMultiMPQIcons () {
     return Form1->MultiMPQIcons;
};

void TForm1::SetMultiMPQIcons (bool MPQIconsState) {
     Form1->MultiMPQIcons = MPQIconsState;
};
//------------------------------------------------------------------------------

String TForm1::GetLastFolder () {
     return Form1->LastFolder;
};

void TForm1::SetLastFolder (String Folder) {
     Form1->LastFolder = Folder;
};
//------------------------------------------------------------------------------

String TForm1::GetMPQName () {
     return Form1->MPQName;
};

void TForm1::SetMPQName (String MPQName) {
     Form1->MPQName = MPQName;
};
//------------------------------------------------------------------------------

String TForm1::GetProgPath () {
     return Form1->ProgPath;
};

void TForm1::SetProgPath (String ProgPath) {
     Form1->ProgPath = ProgPath;
};
//------------------------------------------------------------------------------

String TForm1::GetTempPath () {
     return Form1->TempPath;
};

void TForm1::SetTempPath (String TempPath) {
     Form1->TempPath = TempPath;
};
//------------------------------------------------------------------------------

String TForm1::GetMPQPath () {
     return Form1->MPQPath;
};

void TForm1::SetMPQPath (String MPQPath) {
     Form1->MPQPath = MPQPath;
};
//------------------------------------------------------------------------------

bool TForm1::GetTBLIsMPQImport (int Index) {
     return Form1->TBLIsMPQImport->Bits[Index];
};

void TForm1::SetTBLIsMPQImport (int Index,bool Value) {
     Form1->TBLIsMPQImport->Bits[Index] = Value;
};
//------------------------------------------------------------------------------

bool TForm1::GetIconIsMPQImport () {
     return Form1->IconIsMPQImport;
};

void TForm1::SetIconIsMPQImport (bool Value) {
     Form1->IconIsMPQImport = Value;
};
//------------------------------------------------------------------------------
 
String TForm1::GetMPQTBL (int Index) {
     return Form1->MPQTBLs[Index];
};

void TForm1::SetMPQTBL (int Index, String Value) {
     Form1->MPQTBLs[Index] = Value;
};

String TForm1::GetMPQIcons () {
     return Form1->MPQIcons;
};

void TForm1::SetMPQIcons (String Value) {
     Form1->MPQIcons = Value;
};

//------------------------------------------------------------------------------

bool TForm1::GetUseCustomNames () {
     return Form1->UseCustomNames;
};

void TForm1::SetUseCustomNames (bool Value) {
     Form1->UseCustomNames = Value;
};
//------------------------------------------------------------------------------
